;#Bytecode buffer and address variables for MLC2

;bcOffset dw offset bytecode

;This represents the folowing MLC2 program:
;#MLC2:
;#FNCT MAIN
;	#CLRS
;	#TEXT 10,10,"Hallo Welt%rPress Key",9
;	#SKEY
;	#TEXT 14,22,"Wait 5 sec & exit!',9
;	#WAIT 150
;	#HALT
;#ENDF
;
;Admittedly a quite simply program but good for testing none the less ;)

bytecode:

	headder db 'MLCafxBC'
	csLength dw 21
	dsLength dw 18
	esLength dw 0	;This was supposed to be the length of the ES but is now used as Version information. 
			;Hight Byte = Major version (must be equal to current) Low Byte=Minor Version (must be <= than current version)
			;If Major = 0 then Minor must be equal. This is changed for every released version. Be aware that early interpreters may also
			;exclude (blacklist) certain younger minors if the incompatibility is caused by a compiler bug!
	cseg db 01Eh	;CLRS	: Clear Screen
	     db 80h+10	;PUSH 10: X Position on screen
	     db 80h+10  ;Push 10: Y Position on screen
	     db 34h
	     dw 10	;Push 000Ah (String ptr in data segment)
	     db 80h+9	;Push 9 (color code)
	     db 16h	;TEXT	:MLC2 Text command
	     db 1Bh	;PAUS	:Wait for any key

	     db 80h+14  ;PUSH 14: X Position
	     db 80h+58	;PUSH 22: NExt Line
	     db 34h
	     dw 14	;String Ptr
 	     db 80h+9	;Color mode
	     db 16h	;Text

	     db 34h	;PUSH i16
	     dw 150	;Wait 5 seconds
	     db 022h	;NOW!
	     db 31h	;HALT VM and terminate
	
	dseg:
		StartAddress dw 00h
		PseudoRegs dw 4 dup (0)		;obsolet?
		HalloAddr dw 0FFFFh,0h
		WaitAddr dw 0FFFFh,23
	eSeg:
		db 'HALLO WELT!%rPress Key',0	;A string
		db 'Wait 5 sec & exit!',0	;another string
	
