include inc\compiler.msg
include inc\compiler.mac


MLC2_Headder db 'ML2:'
fnct_headder db '#FNCT '
fkt_info_1 db ' Line: %c%r',0
fkt_info_2 db '@%n Bytes%r',0

ErrorCode db 'Error %n%r',0
	atLine db '@Line: %n%r',0

newline_length dw 1
newline_code db 0

EndOfFile db 0
LineCounter dw 0
MustBePointer db 0

IntegerPrefix 	equ '%'
StringPrefix 	equ '$'

OpCount equ 9
OpTable db '+','-','*','/',':',',','=',' ',0		;OpCount = 8

OperationCache db 0
negNum db 0

Headder_Target:
	Theadder db 'MLCafxBC'
	TCSLength dw 0
	TDSLength dw 0
	TESLength dw 0
	TSSLength dw 0
	TVersion dw 0003h	;The Target version! Change with every release!
BC_Target 	db Bytecode_Size dup (0)

Data_Target:	VStartAddress dw 0FFFFh
	 	dw Data_Size-1 dup (0)
	
Extra_Target 	dw Extra_Size dup (0)	;Contains pointers to St
String_Target db String_Size dup (0)

SCPointer dw 0  ;This is the pointer to the source code that is currently compiled. This is important for the marking of variables and functions since
		;their names have to be determined.
BCPointer dw 0
DSPointer dw 12	;This MUST be 12! 10 bytes are headder data, 1 word reserved for target of ccst
ESPointer dw 2	;1 word reserved for target CCST (think about the reservation above! is it really necessary? //TODO!
SSPointer dw 2

;Syntax of table:

;first string: command name, 4 chars wide
;second value: Opcode of command
;then paramters or 0 if end
;Parameter types are:

; 1: Integer = 3 bytes
; 2: String  = n Bytes + 1
; 3: File = (to be defined) 
; 4: Function = Complex
; 5: Sprite = Complex
; 64+Type: Pointer (to the type below)
; 128+Type: Array of type  see above, 129=int,130=string,192=sprite ...

;The tokenTable contains the length of the parameters of each function.
;The first value is the number of tokens


IF Memory_Method eq mmShared
	oStack:
ELSE
	IF Memory_Method ne mmIndependant
		.err "Unknown Memory Method defined!"
	ENDIF
ENDIF

VariableTable dd Variable_Table_Size	dup (0FFFFFFFFh);This is the table for variable names
							;the data is the same as for the lable table, except, that the position is in the data segment.
LabelTable dd 128	dup (0FFFFFFFFh)		;This is the table for function names.
							;Each label has the folowing data: 1 word of the position of the original name
							;1 word of the position of the target in the bytecode
IF Memory_Method eq mmShared
	aStack:
ELSE
	IF Memory_Method ne mmIndependant
		.err "Unknown Memory Method defined!"
	ENDIF
ENDIF
addressTable dd Address_Table_Size dup (0)		;Each label has the folowing data: 1 word pointer to the functions name in the bytecode, 
							;1 position where in the bytecode to replace the target

labelPtr	dw 0
addrPtr		dw 0
VarPtr		dw 0

LineBuffer db 255 dup (0)
	LF DB '%r',0

TokenParamenters:
		TP_Text db 1,1,2,0	;Color parameter has been removed!
		TP_WAIT db 1,0
		TP_FRUN db 4,0 
		TP_PIXL db 1,1,1,0
		TP_PIXT db 1,1,64+1,0	;64+1 = integer parameter.
		TP_LINE db 1,1,1,1,1,0	;x1,y1,x2,y2,color
		TP_RECT db 1,1,1,1,1,1,0;x1,y1,x2,y2,linecolor,fillcolor
		TP_CSTR db 1,64+2,0
		TP_MFNC db 4,0
		TP_BREG db 1,1,1,1,64+1,0
		

FunctionOpen db 0		;is 1 if we are in a function. Then no new function may be declared inside!

TokenDB db 'CLRS',01Eh
	DW 0

	db 'PIXL',018h
	dw offset TP_PIXL

	db 'LINE',01Ah
	dw offset TP_LINE	;Graphics routine is installed!

	db 'RECT',024h
	dw offset TP_RECT	;Graphics have been written!!!

	db 'PIXT',019h
	dw offset TP_PIXT	;Implement! Needs new type ... //TODO!! Type in table not implemented!!!

	db 'TEXT',016h
	DW offset TP_Text

	db 'CSTR',012h
	dw offset TP_CSTR

	db 'SKEY',01Bh
	DW 0

	db 'WAIT',022h
	dw offset TP_WAIT

	db 'FRUN',02Eh	;(Call i16 command)
	dw offset TP_FRUN

	db 'HALT',031h
	dw 0

	db 'MSET',044h
	dw 0
	
	db 'MFNC',043h
	dw offset TP_MFNC

	db 'BREG',46h
	dw offset TP_BREG

	db 'DBUG',048h
	dw 0

	
	db 'MOFF',047h
	dw 0

	db 0	;This is the end of the tokenDB

TokenSpecialDB 	db 'FNCT'					;A table that defines special commands and their ASM handler procedures.
			dw offset _HandleNewFunction
		db 'FEND'
			dw offset _EndFunction
		db 'FORL'
			dw offset _ForLoop
		db 0

_ForLoop proc
	;//TODO! Implementation is error prone! Check on beginning of for loop!!!
	PUSH DX BX AX 
		LODSB
		CMP AL,' '
		JNE @@needParams

		call _ParseInteger	;From
		CMP byte ptr DS:[SI-1],0
		JE @@need_more_params
		call _ParseInteger	;To
		CMP byte ptr DS:[SI-1],0
		JE @@need_more_params
		call _ParseInteger	;Step
		CMP byte ptr DS:[SI-1],0
		JE @@need_more_params
		MOV BX,0245h		;LDS From again ... = current
		call _Writeword
		;Now write the testing block ...

;//This pointer points to the #FRUN instruction
		MOV DX,word ptr CS:[BCPointer]	;Save the pointer ... we need to jump there later ...

		call _ParseFunction	;Push function position //TODO! Need to fix for functions with parameters
		MOV BL,02Eh
		call _WriteByte		;#FRUN command

		MOV BX,0145h		;LDS Step var [FROM/TO/STEP/FROM/STEP]
		call _WriteWord
		XOR BL,BL
		call _WriteByte		;ADD 2 variables ...	[FROM/TO/STEP/CURRENT]	Current +

		MOV BX,0045h
		call _WriteWord		;LDS result again ...	[FROM/TO/STEP/CURRENT/CURRENT]
		MOV BX,0345h		
		call _WriteWord		;LDS To Var [FROM/TO/STEP/CURRENT/CURRENT/TO]
		MOV BL,07h		
		call _WriteByte		;Compare From and TO (CMPBL To,From)	[CMP CURRENT,TO]
					;--> [FROM/TO/STEP/CURRENT/What?
		MOV BL,034h		;Push i16
		call _WriteByte
		MOV BX,DX		;Target Address  (Loop start)
		call _WriteWord

	;//DEBUG! TODO!
;	MOV BL,048h
;	call _writeByte
	;//DEBUG END

		MOV BL,02Ah
		call _WriteByte		;JMP i16 headder of routine ...
		
		MOV Bl,039h		;DECSP --> Clean remaining from to and step off of stack	
		call _WriteByte		
		call _WriteByte		
		call _WriteByte		
		call _WriteByte		
	POP AX BX DX
	ret
	@@NeedParams:
		MOV BX,CS:[LineCOunter]
		errorMSG CERR_ParamExpected
	@@need_more_params:
		MOV BX,CS:[LineCOunter]
		errorMSG CERR_MParamExpected
endp

_FindFunction proc
	;Actual function name at DS:SI ...
	;Does it exist in the table ... if yes point to the BC position of the function in BX. If not then report CF = 0, else CF=1

	PUSH DI AX DS SI
	MOV BX,offset CS:[labelTable]
	SUB BX,2				;Adjust for first run
	@@readNext: 
		POP SI
		PUSH SI
		ADD BX,2
		MOV DI,word ptr CS:[BX]
		ADD BX,2
		CMP DI,0FFFFh
		JE @@notFound				;Hm ... this is no entry. seems as if it does not yet exist.
		@@readChar: 
			LODSB
			MOV AH,byte ptr CS:[DI]
			INC DI				;Are they equal?
			call _isDelimiter
			JC @@Mayfound			;Found one! These are equal and terminated	
			CMP AL,AH
			JNE @@readNext			;These were not equal ;)
		JMP @@readChar

	@@MayFound:
		XCHG AL,AH		;Both need to have delimiters
		call _isDelimiter
		JNC @@readNext
	@@found:		;Nice we have a Var! Now put the position in the BC to bx and everything should be fine ;)
		MOV BX,word ptr CS:[BX]		;Now
		STC
		JMP short @@ende		
	@@notFound:
		CLC			;No Carry Flag --> Not Found!
	@@ende: POP SI DS AX DI
	ret
endp

_HandleNewFunction proc
	;Functionname @DS:SI ...
	CMP byte ptr CS:[FunctionOpen],1
	JE @@errorNested
	MOV byte ptr CS:[FunctionOpen],1
	PUSH DS SI AX
	LODSB
	CMP AL,' '
	JNE @@expect_name
	call _FindFunction
	JC @@already_defined

	;Add it to the function table
		MOV BX,offset CS:[LabelTable]
		ADD BX,word ptr CS:[labelPtr]

		MOV AX,SI				;the position of the current line
		SUB AX,offset LineBuffer		;should be seen as in the code not as in the line buffer
		ADD AX,word ptr CS:[SCPointer]			;so adjust it. .... done!

		MOV word ptr CS:[BX],AX
		MOV AX,word ptr CS:[BCPointer]		;What should this label represent?
		ADD BX,2
		MOV word ptr CS:[BX],AX			;Write the current BC Position
		ADD CS:[labelPtr],4

	PUSH SI
	LODSW
	CMP AX,'AM'
	JNE @@noMain
	LODSW
	CMP AX,'NI'
	JNE @@noMain
	LODSB
	CMP AL,0
	JNE @@noMain
	MOV AX,word ptr cS:[BCPointer]
	MOV word ptr CS:[VStartAddress],AX

	@@noMain:
	;Test if the name is MAIN - if yes set the appropriate pointer so that the program start is correct
	
	POP SI
	@@areParameters:
		LODSB
		CMP AL,','
		JE @@paramsfound
		CMP AL,0
		JNE @@areParameters
	POP AX SI DS
	ret
	@@paramsfound:
		LODSB
		SUB AL,48
		CMP AL,9	;.. 0 till 8 are valid for parameters 1-9
		JA @@error_strangeParam
;//Params OK!
	
	@@expect_name:
		MOV BX,word ptr CS:[LineCounter]
		errorMSG CERR_No_FNCTName
	@@errorNested:
		MOV BX,word ptr CS:[LineCounter]
		errorMSG CERR_FunctionNested
	@@already_defined:
		MOV BX,word ptr CS:[LineCounter]
		errorMSG CERR_AlreadyDefined
	@@error_strangeParam:
		MOV BX,word ptr CS:[LineCOunter]
		errorMSG CERR_StrangeParams
endp

_EndFunction proc
	CMP byte ptr CS:[FunctionOpen],1
	JNE @@error_Not_Open
	MOV byte ptr CS:[FunctionOpen],0

	PUSH BX
	MOV BL,042h
	call _WriteByte		;Write ret 0 (0 = 0 parameters) parameters are implemented later .. need to think some more about those ..
	POP BX
	ret
	@@error_not_open:
		errorMSG CERR_Fnct_Not_Open
endp

_FindVariable proc							;Seems to be bug free as of 12-23-2005
	;In: DS:SI pointer to variable, sperated by OpTable value
	;Out: CF=1 --> BX = Position in the DATA segment; CF=0 not found
	PUSH DI AX DS SI
	MOV BX,offset CS:[variableTable]
	SUB BX,2				;Adjust for first run
	@@readNext: 
		POP SI
		PUSH SI
		ADD BX,2
		MOV DI,word ptr CS:[BX]
		ADD BX,2
		CMP DI,0FFFFh
		JE @@notFound				;Hm ... this is no entry. seems as if it does not yet exist.
		@@readChar: 
			LODSB
			MOV AH,byte ptr CS:[DI]
			INC DI				;Are they equal?
			call _isDelimiter
			JC @@Mayfound			;Found one! These are equal and terminated	
			CMP AL,AH
			JNE @@readNext			;These were not equal ;)
		JMP @@readChar
	@@MayFound:
		XCHG AL,AH		;Both need to have delimiters
		call _isDelimiter
		JNC @@readNext
	@@found:		;Nice we have a function! Now put the position in the data segment to bx and everything should be fine ;)
		MOV BX,word ptr CS:[BX]		;Now
		STC
		JMP short @@ende		
	@@notFound:
		CLC			;No Carry Flag --> Not Found!
	@@ende: POP SI DS AX DI
	ret
endp	


_compile proc
	;DS:SI = MLC2 COde
	CLS	
	PUSH ES DI CX AX BX
	;call _ParseNewLine	--> change new lines to 0
	MOV CX,4	
	PUSH @CODE
	POP ES
	MOV word ptr CS:[LineCounter],0
	MOV DI,offset CS:[MLC2_headder]
	MOV CX,4
	REP CMPSB
	JNE @@error_noMLC2
	MOV word ptr CS:[DSPointer],12	;The 10 first bytes are not yet needed or initialized later :D
	Inc sI
	@@liner:
		MOV word ptr CS:[SCPointer],SI	;Preserve the start of the line to register variables if they exist.
		call _GetLine			;Now the line is in the Line Buffer

		INC word ptr CS:[LineCounter]
		call _TranslateLine		;Parse this line now
		
		CMP byte ptr CS:[EndOfFile],0
		JE @@liner
	MOV BL,031h
	call _writebyte
	MOV word ptr CS:[TCSLength],ByteCode_SIze
	MOV word ptr CS:[TDSLength],Data_Size*2
	MOV word ptr CS:[TESLength],Extra_Size
	MOV AX,CS:[SSPointer]
	MOV word ptr CS:[TSSLength],AX		 ;The rest will be ignored
	CMP word ptr CS:[VStartADdress],0FFFFh		;Has there a main function been defined?
	JE @@error_NoEntry
	call _PassFunctions		;Correct function calls (forwarding)

	CMP byte ptr CS:[FunctionOpen],0
	JNE @@error_Open

	pOP BX AX CX DI ES
	ret
	@@error_noMLC2:
		errormsg CERR_No_headder
	@@error_noEntry:
		errorMsg CERR_No_Main
	@@error_Open:
		errorMsg CERR_FunctionOpen
endp

_ReserveVariable16 proc	;At DS:SI is the variable name. It should be sperated by one of the seperator signs. Only these are recognized!
	;After execution BX is a pointer to a 16 bit reserved data space!
	PUSH AX
	call _FindVariable
	JNC @@create
	@@ende: 
		Pop AX
		ret		;Now we have space reserved and the offset location is at :BX
	@@create:		;write 1 word (SI) and another word (varPtr) and then increase VarPtr (to point at next location) and FSPointer
		MOV BX,offset CS:[variableTable]
		ADD BX,word ptr CS:[varPtr]

		MOV AX,SI				;the position of the current line
		SUB AX,offset LineBuffer		;should be seen as in the code not as in the line buffer
		ADD AX,word ptr CS:[SCPointer]			;so adjust it. .... done!

		MOV word ptr CS:[BX],AX
		MOV AX,word ptr CS:[DSPointer]
		ADD BX,2
		MOV word ptr CS:[BX],AX
		MOV BX,word ptr CS:[DSPointer]			;Preserve this because the result of the op needs to be rewritten to this place
		ADD word ptr CS:[DSPointer],2
		ADD CS:[VarPtr],4
		CLC
		JMP @@ende				;It seems done!This routine should in any case return a writeable position in DS after execution.
endp

_ReserveStringVariable16 proc	;At DS:SI is the variable name. It should be sperated by one of the seperator signs. Only these are recognized!
	;After execution BX is a pointer to a 16 bit reserved data space!
	PUSH AX
	call _FindVariable
	JNC @@create
	@@ende: 
		Pop AX
		ret		;Now we have space reserved and the offset location is at :BX
	@@create:		;write 1 word (SI) and another word (varPtr) and then increase VarPtr (to point at next location) and FSPointer
		MOV BX,offset CS:[variableTable]
		ADD BX,word ptr CS:[varPtr]

		MOV AX,SI				;the position of the current line
		SUB AX,offset LineBuffer		;should be seen as in the code not as in the line buffer
		ADD AX,word ptr CS:[SCPointer]			;so adjust it. .... done!

		MOV word ptr CS:[BX],AX
		MOV AX,word ptr CS:[ESPointer]
		ADD BX,2
		MOV word ptr CS:[BX],AX
		MOV BX,word ptr CS:[ESPointer]			;Preserve this because the result of the op needs to be rewritten to this place
		ADD word ptr CS:[ESPointer],2
		ADD CS:[VarPtr],4
		CLC
		JMP @@ende				;It seems done!This routine should in any case return a writeable position in DS after execution.
endp


_GetLine proc	;Do not preserve DS:SI since they must point to the next line upon termination of this function
	PUSH ES DI CX
	call _ScanForLengthOfLine	;Length of the next line is in CX
	PUSH @CODE
	POP ES
	MOV DI,offset LineBuffer
	REP MOVSB
	LODSB
	DEC SI
	CMP AL,0
	JNE @@ende
	MOV byte ptr @CODE:[EndOfFile],1
	@@ende: POP CX DI ES
	ret
endp


_TranslateLine proc
	PUSH DX AX BX CX DS SI ES DI
	MOV SI,CS			
	MOV DS,SI
	MOV ES,SI
	MOV SI,offset CS:[LineBuffer]
	MOV DI,offset CS:[TokenDB]
	call _FindCode
	JC @@testForAdvCommand

	;parse the parameters and push them
	call _ParseParameters	;Pointer to parameter desctiption is still in DX ... test for all the parameters and add the push commands of them

	;Write the commands code
	POP DI ES		;Return the position in the bytecode
	MOV AL,BL
	STOSB

	@@return: POP SI DS CX BX AX DX	;Do not add DI and ES! See 3 lines above ...
	ret
	@@testForAdvCommand:
		CMP BX,1
		JE @@testforassign
		MOV SI,offset CS:[LineBuffer]
		MOV DI,offset CS:[TokenSpecialDB]
		call _FindAdvancedCode
		POP DI ES
		JC @@error			;TODO: Handly correctly later ...
		;OK! In BX we have the actual handler ... so call it!
		call BX
		JMP @@return
	@@testForAssign:
		POP DI ES	;To avoid conflic with above push/pops
		CMP BX,1
		;Its not 1? Then the error is elsewhere ... jump to handler
		JNE @@error
	
		DEC SI		;adjust it to the beginning of the string again.
		MOV BX,SI	;Well that was no command? So lets go back and check what it is! Maybe its an assignment
		@@looper_equal:
			LODSB
			CMP AL,'='
			JE @@is_Equation
			CMP AL,0
			JE @@error		;ITs also no equation? thats bad ... I think we have an error over here: 
			JMP @@looper_equal
		@@is_Equation:			;We have an equation here!
			MOV SI,BX		;And again back to the start ... So what is it that is assigned?
			LODSB
			CMP AL,IntegerPrefix	;Is it an integer? If yes then handle it!
			JE @@handle_int
			CMP AL,StringPrefix	;Is it a string? If yes then what ...? Of course! handle it ;)
			JNE @@error
			JMP @@handle_str

			;NoInt?  NoStr? Thats bad ...

	@@error:
		CLS
		Print ErrorCode
		MOV BX,CS:[LineCOunter]
		Print AtLine
		Print LineBuffer
		Print LF
		WaitForAnyKey
		errorMsg CERR_UnknownCommand
		JMP @@return

	@@handle_int:			;Wow! We got an integer here ... so lets treat it with respect ;)
		LODSB
		CMP AL,48		;the integers %0 - %9 are reserved!
		JB @@no_risk
		CMP AL,57
		JA @@no_risk
		LODSB
		CMP AL,'='
		JE @@error1
		DEC SI
		@@no_risk:
		SUB SI,2			;AS always ... decrease SI to have the "real" complete name
		call _ReserveVariable16	;OK! Now we can write to offset BX in the DATA segment! .. so preserve BX and do the calculations ...
		;Skip till =
		@@looper:
			LODSB
			CMP AL,'='
			JNE @@looper
		call _ParseInteger		;Now parse the remaining parameters

		CMP BH,127
		JBE @@small_Pusher
		MOV AX,BX	
		MOV BL,3Bh
		call _WriteByte		;Write the POP m16 (push value in BX to a 16 bit ram address)
		MOV BX,AX
		call _WriteWord		;Write the word that should be pushed
		JMP @@return
				
		@@small_pusher:
		MOV BH,BL
		MOV BL,03Ah
		call _WriteByte
		XCHG BL,BH
		call _WriteByte		;Now write the 8 bit location ... nice eh`? ;)
		JMP @@return

	@@handle_str:		;Nice thing .. so there is a string ... well lets see what we can do with this one ...
;		JMP @@return
		MOV AH,0		;if it stays 0 then the variable has been newly created
		DEC SI			;And once again .. decrease SI so that we have the real name ...
		call _ReserveStringVariable16	;String can now be placed at esPointer

		;Skip till after the "=" sign ...
		@@loader: LODSB
			CMP AL,'='
		JNE @@loader

		;Then parse the string ...
		call _ParseString

		;and do a Pop m8 or m16 of the value to mem @ BX since the current position is on stack and must be on memory
	;Test!
		PUSH BX

		MOV BL,049h	;Create String Copy (necessary since the new instance will be destroyed on string changes!)
		call _WriteByte	;The new instance will then be on the stack

;Clear Old String
		MOV BL,04Ch
		call _WriteByte
		
		POP BX
		PUSH BX
		call _WriteWord


		MOV BL,04Ah
		call _WriteByte

		POP BX
		call _WriteWord		;Write to variables ES			
		
		
		JMP @@return
	@@error1:		;The paramters %0-%9 are local and reserved! NO assignment possible ...
		MOV BX,CS:[LineCOunter]
		errorMSG CERR_Reserved_Local
endp

_ParseParameters proc	;DX has ptr to parameter description and DS:SI points to the next char of the line.
	PUSH AX
	MOV byte ptr CS:[MustBePointer],0
	LODSB		;Read the next char of the command (either 0 (if no parameters) or space char
	CMP DX,0
	JE @@no_parameters
	CMP AL,' '
	JNE @@parameters_expected
	MOV DI,DX
	@@paramLoop:
		MOV byte ptr CS:[MustBePointer],0
		MOV AH,byte ptr ES:[DI]
		INC DI
		CMP AH,0
		JE @@return

		CMP byte ptr DS:[SI-1],0
		JE @@more_parameters_Expected

		MOV AL,AH
		AND AL,64	;Is the thing a pointer? Then the 64 Bit is set //TODO! Replace with native commands
		CMP AL,64
		JNE @@noPointer
		MOV byte ptr CS:[MustBePointer],1
		SUB AH,64
		PUSH AX
		LODSB
		CMP AL,'*'
		JNE @@Pointer_Expected
		POP AX
		@@noPointer:
		
		MOV AL,AH
		CMP AL,1
		JE @@parseInt
		CMP AL,2
		JE @@parseStr
		CMP AL,3
		JE @@parseNI
		CMP AL,4
		JE @@parseFnc
		CMP AL,5
		JAE @@parseNI
		JMP @@parseWTT
	@@return: 
		CMP byte ptr DS:[SI-1],0
		JNE @@tooManyParams
	@@return2:
		POP AX
		call _writeByte		;Write the actuall command ...
		ret
	@@parseInt:
		call _ParseInteger	;DS:SI = Pointer to the parameter
		JMP @@paramLoop
	@@parseStr:
		PUSH AX
		MOV AH,0		;Don't watch boundarys
		call _ParseString	;DS:SI = Pointer to parameter
		POP AX
		JMP @@paramLoop
	@@no_parameters:
		CMP AL,0
		JE @@return2
		MOV BX,word ptr CS:[LineCounter]
		errorMSG CERR_NoParamsExpected
	@@parameters_expected:
		MOV BX,CS:[LineCOunter]
		errorMSG CERR_ParamExpected
	@@parseFnc:
		call _ParseFunction
		JMP @@paramLoop
	@@more_parameters_expected:
		MOV BX,CS:[LineCOunter]
		errorMSG CERR_MParamExpected
	@@Pointer_Expected:
		MOV BX,CS:[LineCounter]
		errorMSG CERR_PointerExpected
	@@tooManyParams:
		MOV BX,CS:[LineCOunter]
		errorMSG CERR_TooManyParams
	@@parseNI:
		errorMSG CERR_IE_ParamNI
	@@parseWTT:
		XOR BX,BX
		MOV BL,AL
		errorMSG CERR_IE_WTTError
endp

_ParseFunction proc
	;DS:SI should be the function ... so find it ..
	PUSH AX BX
	call _FindFunction	;If found Bc Pos in BX else CF=0
	JNC @@revCall

@@write: MOV AX,BX
	MOV BL,34h
	call _WriteByte		;Write the PUSH i16 byte
	MOV BX,AX

	call _WriteWord		;The word should be in BX if found ... so write this position

;Skip on till delimiter (hindered detection of parameters!)
	@@moveon:
		LODSB
		call _isDelimiter
		JNC @@moveon
	POP BX AX
	ret

	@@revCall:		;The Function is not yet defined! Put it in the table and wait for the final pass to find it again ...
	MOV BX,word ptr CS:[addrPtr]
	CMP BX,Address_Table_Size
	JE @@error_table_full
	ADD BX,offset CS:[addressTable]

	MOV AX,SI
	SUB AX,offset CS:[LineBuffer]		;should be seen as in the code not as in the line buffer
	ADD AX,word ptr CS:[SCPointer]			;so adjust it. .... done!

	MOV word ptr CS:[BX],AX

	ADD BX,2
	MOV AX,word ptr CS:[BCPointer]
	INC AX
	MOV word ptr CS:[BX],AX
	ADD word ptr CS:[addrPtr],4
	MOV BX,0FFFFh
	JMP @@write
	@@error_table_full:
		errorMSG CERR_Table_Full
	;TODO: Optimize this by trying to free space in the table ...

endp

_ParseInteger proc
	;Read first char and test for a number or one of the integer prefixes (only % for now!)
	PUSH AX BX
	MOV byte ptr CS:[OperationCache],0
	MOV byte ptr CS:[negNum],0
@@checkVar:	XOR BX,BX
	LODSB
	CMP AL,'0'
	JB @@nan
	CMP AL,'9'
	JA @@nan

@@goon:	CMP byte ptr CS:[MustBePointer],1
	JE @@Cant_Be_Number
	SUB AL,48
	MOV BL,AL
	JMP @@looper
	@@Cant_Be_Number:
		MOV BX,CS:[LineCounter]
		errorMSG CERR_Pointer_CantBeNumber

	@@looper:
		XOR AH,AH
		LODSB
		call _isDelimiter	;CF if delimiter = AL
		JC @@PushTheValue	;Op in AL, Value in BX
		;No CF? Then the number goes on .. 
		CMP AL,'0'
		JB @@nan
		CMP AL,'9'
		JA @@nan
		SUB AL,48
		PUSH AX DX
		MOV AX,10
		MUL BX
		CMP DX,0
		JNE @@ToBig
		MOV BX,AX
		POP DX AX
		ADD BX,AX
		CMP BX,0111111111111111b	;Number too big? --> negative result 
		JBE @@looper
	@@ToBig:
		MOV BX,CS:[LineCounter]
		errorMSG CERR_ToBig
	@@nan:
		CMP AL,IntegerPrefix
		JE @@variableInt
		CMP AL,'-'
		JNE @@noNeg
		JMP @@negativeNumber
	@@noNeg:
;		CMP AL,0
;		JNE @@error1
;		CMP byte ptr CS:[OperationCache],0
;		JNE @@DoLastMath
		@@error1: MOV BX,CS:[LineCOunter]
		errorMSG CERR_integerExpected

	@@variableInt:	;The new handler for variables ...
		DEC SI
		call _reserveVariable16		;DS:SI is variable name position, BX --> return position in DS
						;Variable has been created / found, Position is in BX
		@@readOn: LODSB
		call _isDelimiter
		JNC @@readOn
		CMP BH,0
		JE @@small_Pusher2
		CMP byte ptr CS:[MustBePointer],1
		JE @@pushTheValue		;Write the value (it is in BX, and since it is a pointer write the address)
		PUSH BX
		MOV BL,36h
		call _WriteByte		;Write the PUSH m16 (push value in BX to a 16 bit ram address)
		POP BX
		call _WriteWord		;Write the word that should be pushed
		JMP @@finish
				
		@@small_pusher2:
		PUSH BX
		MOV BL,035h
		call _WriteByte
		POP BX
		call _WriteByte		;Now write the 8 bit location ... nice eh`? ;)
		JMP @@finish
	@@pushTheValue:
		CMP byte ptr CS:[negNum],'n'
		JNE @@not_neg

		db 00Fh,01Fh,0C3h,0Fh	;Not1 BX,15

		@@not_neg:
		CMP BX,127
		JBE @@small_Pusher
		PUSH BX		;Preserve the delimited
		MOV BL,34h
		call _WriteByte		;Write the PUSH i16 byte
		POP BX
		call _WriteWord		;Write the word that should be pushed
	@@finish: 
		CMP AL,','
		JE @@ende
		CMP AL,0
		JE @@ende
		CMP byte ptr CS:[MustBePointer],1
		JNE @@Can_Be_Number
		JMP @@Cant_Be_Number
	@@Can_Be_Number:
		CMP byte ptr CS:[OperationCache],0
		JE @@noWrite
		call _WriteMath			;write the math op if there was one previously
;Handle math operations over here.
	@@noWrite: MOV byte ptr CS:[OperationCache],AL
		JMP @@CheckVar
	@@small_pusher:
		ADD BL,80h	;in BL is the new bytecode!
		call _WriteByte
		JMP @@finish		
	@@negativeNumber:
		MOV byte ptr CS:[negNum],'n'		
		LODSB
		JMP @@goon
	@@ende: 
		CMP byte ptr CS:[OperationCache],0
		JE @@endeNoOp
		call _WriteMath			;Write the math op thats in the cache
	@@EndeNoOp:
		POP BX AX
		ret
endp

_WriteMath proc
	CMP byte ptr CS:[OperationCache],'+'
	JE @@addPlus
	CMP byte ptr CS:[OperationCache],'-'
	JE @@addMinus
	CMP byte ptr CS:[OperationCache],':'
	JE @@addMod
	CMP byte ptr CS:[OperationCache],'/'
	JE @@addDiv
	CMP byte ptr CS:[OperationCache],'*'
	JE @@addMul
	CMP byte ptr CS:[OperationCache],'n'
	JE @@addneg
	MOV BX,word ptr CS:[LineCounter]
	errorMSG CERR_InvalidMath
	@@addMod: MOV BL,5
		call _WriteByte
		ret
	@@addPlus: XOR BL,BL
		call _WriteByte
		ret
	@@addMinus: MOV BL,1	;Write the command as Neg / ADD instead of - Should have the same result
		call _WriteByte
		ret
	@@addDiv: MOV BL,4
		call _writeByte
		ret
	@@addMul: MOV BL,3
		call _WriteByte
		ret		;STUB, write the math operation here ...
	@@addNeg: MOV BL,2
		call _WriteByte
		ret
endp

_WriteByte proc		;This and the next proc write the actual bytecode
	PUSH ES DI AX

	PUSH seg BC_Target
	POP ES
	MOV DI,offset BC_Target
	ADD DI,word ptr CS:[BCPointer]
	MOV AL,BL
	STOSB
	INC word ptr CS:[BCPointer]

	POP AX DI ES
	ret
endp

_WriteWord proc
	PUSH ES DI AX

	PUSH seg BC_Target
	POP ES
	MOV DI,offset BC_Target
	ADD DI,word ptr CS:[BCPointer]
	MOV AX,BX
	STOSW
	ADD word ptr CS:[BCPointer],2

	POP AX DI ES
	ret
endp


_isDelimiter proc
	PUSH BX
	CLC

	MOV BX,OpCount

	@@compare: CMP CS:[opTable+BX],AL
		JE @@isDelimiter
		CMP BX,0
		JE @@ende
		DEC BX
		JMP short @@compare
	@@isDelimiter:
		STC
	@@ende:	POP BX
	ret
endp

_ParseString proc		
		;One thing I'd like to add is string substraction where the all occurences of the string after the - are removed from the string.
		;String replacement could be done using the ... (damn it ... i forgot to type this in and now forgot how I intended it to work ... gotta think 'bout it again.
		;//TODO! This function is not pointer aware. If the value is "Must be pointer" then generate exception on  non variable
			
	PUSH BX AX ES DI
	LODSB
	CMP AL,StringPrefix
	JNE @@NoVariableStr
		JMP @@VariableStr
      @@noVariableStr:
	CMP byte ptr CS:[MustBePointer],1
	JE @@Cant_Be_String
	DEC SI
	PUSH seg extra_Target
	POP ES
	MOV DI,offset extra_Target
	ADD DI,word ptr CS:[ESPointer] ;ES:DI is at the next free place in string segment!

;Create new string pointer ...
	MOV AX,word ptr CS:[SSPointer]
	STOSW		;Pointer to next string -> ES

	MOV AX,seg String_Target
	MOV ES,AX
	MOV DI,offset String_Target
	ADD DI,word ptr CS:[SSPointer]

	LODSB
	MOV AH,AL		;Fix the termination sign in AH
	
	@@loader: LODSB 
	CMP AL,0
	JE @@error
	STOSB
	INC word ptr CS:[SSPointer]		;Adjust ES positions
	CMP AL,AH				;Test if it is a terminated string
	JNE @@loader
	DEC DI
	XOR AX,AX
	STOSB

	MOV DI,word ptr CS:[ESPointer]			;Preserve this because the result of the op needs to be rewritten to this place
	
	MOV AX,DI
;	ADD word ptr CS:[DSPointer],2
;	ADD DI,word ptr CS:[vmDSBaseOff]
;	MOV ES,word ptr CS:[VMDsBaseSeg]
;	MOV word ptr ES:[DI],BX
	
;AX is the position in ES ...

;	MOV AX,BX
	ADD word ptr CS:[ESPointer],2	;Point to next string
	CMP AX,127
	JBE @@small_Pusher
	MOV BL,34h
	call _WriteByte		;Write the PUSH i16 byte
	MOV BX,AX
	call _WriteWord		;Write the word that should be pushed


@@finish:
	LODSB
	CMP AL,','
	JNE @@trailing

	@@done: POP DI ES AX BX
	ret
	@@cant_be_string:
		MOV BX,CS:[LineCounter]
		errorMSG CERR_Pointer_CantBeString
		

@@VariableStr:
	DEC SI
	call _FindVariable	;Look up the variable and put its ES position in BX
	JNC @@error_str_nd	;The differenz between strings and integers is, that strings are ccstr'ed and ints are added! This is how the
				;Interpreter distinguishes them. Now Push the value at BX in DS to the stack (string pos in DS). 

	;Skip Till delimiter ...
						;Variable has been created / found, Position is in BX
	@@readOn: LODSB
		call _isDelimiter
	JNC @@readOn
	DEC SI

	MOV AX,BX
	MOV BL,34h
	call _WriteByte		;Write the PUSHi16 byte
	MOV BX,AX
	call _WriteWord		;Write the word that should be pushed
	JMP @@finish

	@@error:
		MOV BX,word ptr CS:[LineCounter]
		errorMSG CERR_UnterminatedString
	@@trailing:
		cmp al,'+'
		JE @@concat
		cmp al,0				;The line is done. End it ;)
		JE @@done
		MOV BX,word ptr CS:[LineCounter]
		errorMSG CERR_TailingChar
	@@small_pusher:
		OR AX,080h
		MOV BX,AX
		call _WriteByte
		JMP @@finish		
	@@concat:
		CMP CS:[MustBePointer],1
		JE @@cant_be_string		;Pointers can't be added.
		call _ParseString
		MOV BL,11h
		call _WriteByte
		JMP @@done
;	@@small_pusher2:
;		CMP CS:[mustBePointer],0
;		JNE @@PPush
;		PUSH BX
;		MOV BL,35h	;in BL is the new bytecode!
;		call _WriteByte
;		POP BX
;		call _WriteByte
;		JMP @@finish
	@@error_str_nd:		;Well, lets add stubs and use undefined strings too!
		;So create a string
		;Reserve variable ...
;JMP @@olderror
		PUSH DS SI
		call _ReserveStringVariable16		;Ok ... so we have one in BX ...
		POP SI DS
		JMP @@readOn
 
@@olderror:

		MOV BX,word ptr CS:[LineCounter]
		errorMSG CERR_Str_ND	;Handle also forward referencing in future!
	@@PPush:
		ADD BL,80h
		call _writeByte
		JMP @@finish
endp

_FindAdvancedCode proc ;DS:SI = COmmand, ES:DI = Table (0 term), out: BX=Offset of proc,CF=1 if no function found
	PUSH AX CX
	LODSB 
	PUSH SI
	@@finder:
		POP SI
		PUSH SI
		CMP byte ptr ES:[DI],0
		JE @@NotFound
		MOV CX,4
		REP CMPSB
		JE @@found_Command
		ADD DI,CX
		ADD DI,2
		JMP short @@finder
	@@notFound:
		MOV BX,2	;Code for not found
		STC
		JMP short @@ENDE
	@@Found_Command:
		MOV BX,word ptr ES:[DI]
		CLC
	@@Ende: POP AX 	;routine is supposed to modify SI so do not change!
		POP CX AX
		ret
	ret
endp

_FindCode proc		;Line in DS:SI , ES:DI=TokenTable, BL = Function Number, DX=Pointer to Parameter descriptor, if CarryFlag then BX = ErrorCode
	PUSH AX CX
	LODSB 
	PUSH SI
	CMP AL,'#'
	JNE @@NoCommand		;It seems to be a command ... now look it up ... Table is in ES:DI
	@@finder:
		POP SI
		PUSH SI
		CMP byte ptr ES:[DI],0
		JE @@NotFound
		MOV CX,4
		REP CMPSB
		JE @@found_Command
		ADD DI,CX
		ADD DI,3
		JMP short @@finder
	@@notFound:
		MOV BX,2	;Code for not found
		STC
		JMP short @@ENDE
	@@Found_Command:
		MOV BL,byte ptr ES:[DI]
		MOV DH,byte ptr ES:[DI+2]
		MOV DL,byte ptr ES:[DI+1]
		CLC
	@@Ende: POP AX 	;routine is supposed to modify SI so do not change!
		POP CX AX
		ret
	@@NoCommand:
		MOV BX,01	;Code for no command
		STC
		JMP short @@ende
endp

_ScanForLengthOfLine proc
	;DS:SI = line
	PUSH DS SI AX
	XOR CX,CX
	@@repeater:
		inc CX
		LODSB
		CMP AL,0
		JNE @@repeater
	;CX = length 
	POP AX SI DS
	Ret
endp

_PassFunctions proc
	;This is the final pass for functions. Here all forwarded functions are getting their correct jump address.
	PUSH BX AX ES DI DS SI

	CMP word ptr CS:[AddrPtr],0		;Are there any addresses needed to be defined?
	JE @@done

@@repeat:	
	SUB word ptr CS:[AddrPtr],4	;ADjust to last used entry ..
	MOV BX,word ptr CS:[addrPtr]
	ADD BX,offset CS:[addressTable]
	MOV SI,word ptr CS:[BX]

	ADD BX,2
	MOV AX,word ptr CS:[BX]
	call _FindFunction
	JNC @@notFound
	MOV word ptr CS:[BCPointer],AX
	call _WriteWord
	CMP word ptr CS:[ADdrPtr],0
	JNE @@repeat
	
	
	@@done: POP SI DS DI ES AX BX
	ret
	@@notFound:
		CLS
		call _Print
		Print CERR_FNF
		

endp