DEbugMessage db '******************%r*Debugger invoked*%r******************%r',0
labelPtrStr db 'Line Counter: %n%r',0
addressPtrStr db 'Addr Pointer: %n%r',0

include inc\debugger.mac

saveit db 0
saved dw 0
debugTable 	db 'ADD     '
		db 'SUB     '
		db 'NEG     '
		db 'MUL     '
                db 'DIV     '
		db 'MOD     '
		db 'CMPEQ   '
		db 'CMPBL   '
		db 'CMPAB   '
		db 'CMPEQ   '
		db 'CMPNBL  '
		db 'CMPAB   '
		db 'AND     '
		db 'OR      '
		db 'NOT     '
		db 'SHL     '
		db 'SHR     '
		db 'CCST    '
		db 'I2S     '
		db 'S2I     '
		db 'GETCH   '
		db 'SETCH   '
		db 'TEXT    '
		db 'DBMP    '
		db 'PIXL    '
		db 'PIXT    '
		db 'LINE    '
		db 'SKEY    '
		db 'SIZE    '
		db 'CLSN    '
		db 'CLRS    '
		db 'DISP    '
		db 'GKEY    '
		db 'WKEY    '
		db 'WAIT    '
		db 'SHFT    '
		db 'RECT    '
		db 'JMPi8   '
		db 'JMPi16  '
		db 'JMPm8   '
		db 'JMPm16  '
		db 'JCCi8   '
		db 'JCCi16  '
		db 'JCCm8   '
		db 'JCCm16  '
		db 'CALLi8  '
		db 'CALLi16 '
		db 'CALLm8  '
		db 'CALLm16 '
		db 'HALT    '
		db 'RSTA    '
		db 'RSTO    '
		db 'PUSHi16 '
		db 'PUSHm8  '
		db 'PUSHm16 '
		db 'PUSHPm8 '
		db 'PUSHPm16'
		db 'DECSP   '
		db 'POPm8   '
		db 'POPm16  '
		db 'POPPm8  '
		db 'POPPm16 '
		db 'MOVm8   '
		db 'MOVm16  '
		db 'MOVPm8  '
		db 'MOVPm16 '
		db 'RET     '
		db 'MFNC    '
		db 'MSET    '
		db 'LDS     '
		db 'BREG    '
		db 'MOFF    '
		db 'DBG     '
		db 'CSC     '
		db 'POPmE16 '
		db 'CSI     '
		db 'CLRSTR  '

_debugApplication proc
	Cls
	Print DebugMessage
	MOV BX,word ptr CS:[LineCounter]
	Print labelPtrStr
	MOV BX,word ptr CS:[addrPtr]
	Print AddressPtrStr
	WaitForAnyKey
	ret
endp

invoke_debugger proc
	PUSH ES DI DS SI CX AX
;	MOV AX,01A20h
;	MOV ES,AX
;	MOV DS,AX

;	XOR SI,SI
;	MOV DI,1024*4	;4 Pages --> next 4 pages (Backup Screen)
;	MOV CX,1024*2
;	REP MOVSW

	MOV BX,0101h
	MOV CX,8040h
	MOV AX,0800h
	call _Rect

	ADD BX,0101h
	MOV CX,7F09h
	MOV AX,0808h
	call _Rect

	MOV BX,0109h
	MOV CX,2640h
	MOV AX,0800h
	call _Rect


	MOV CS:[Cursor],3001h
	Print VM_DebugMenuText
;Debugger Menus
	MOV byte ptr CS:[Narrow],1
	MOV CS:[Cursor],020Bh
	Print VM_DebugOStack
	MOV CS:[Cursor],0213h
	Print VM_DebugaStack
	MOV CS:[Cursor],021Bh
	Print VM_DebugProgram
	MOV CS:[Cursor],0222h
	Print VM_DebugTrace
	MOV CS:[Cursor],022Ah
	Print VM_DebugVariablesDS
	MOV CS:[Cursor],0231h
	Print VM_DebugVariablesES
	MOV CS:[Cursor],0239h
	Print VM_DebugExit
	MOV CS:[Cursor],0241h

	MOV byte ptr CS:[Narrow],0

	MOV DI,1
	@@drawer: call _Highlight2
	@@WaitLoop: 
		TestKey	KEY_Up
		JE @@up
		TestKey Key_Down
		JE @@down
		TestKey KEY_EXE
	JNE @@WaitLoop		;WARNING! Interrupts are disabled to not interfere with keyboard and mouse handlers!

	CMP DI,1
	JE @@1
	CMP DI,2
	JE @@2
	CMP DI,3	;We must do the "represent bytecode" to do this .. .well ... this will still take some time I guess ;)
	JE @@3
	CMP DI,4	;Trace debug is not yet implemented in the interpreter ... maybe later ;)
	JE @@4
	CMP DI,5	;Variables debug needs debug symbols to be implemented into compiler
	JE @@5
	CMP DI,6
	JE @@6

;	MOV AX,01A20h
;	MOV ES,AX
;	MOV DS,AX
;
;	XOR DI,DI
;	MOV SI,1024*4	;4 Pages --> next 4 pages
;	MOV CX,1024*2
;	REP MOVSW
	JMP @@endVmDebug

	@@down:
		call _HighLight2
		@@looper: TestKey KEY_Down	;ignore multi press
		JE @@looper
		INC DI
		CMP DI,8
		JNE @@Drawer
		MOV DI,1
		JMP @@drawer
	@@up:
		call _Highlight2
		@@looper1: TestKey KEY_Up	;ignore multi press
		JE @@looper1
		DEC DI
		CMP DI,0	
		JE @@no_drawer
			JMP @@drawer
  		@@no_drawer:
		MOV DI,7
		JMP @@drawer

	@@endVMDebug:
	POP AX cX SI DS DI ES
	ret

@@1:
	call _debug_o_stack
	JMP @@WaitLoop
@@2:
	call _debug_a_stack
	JMP @@WaitLoop
@@3:
	call _debug_program_source
	JMP @@WaitLoop
@@4:
	call _debug_varsSS
	JMP @@WaitLoop
@@5:
	call _debug_varsDS
	JMP @@WaitLoop
@@6:
	call _debug_varsES
	JMP @@waitLoop
	
endp

HighLights2 db 0Ah,12h,1Ah,21h,29h,30h,37h,3Fh

_Highlight2 proc
	;DI = Item
	PUSH CX BX AX
	MOV BH,02h
	MOV CH,25h
	MOV BL,byte ptr CS:[HighLights2+DI-1]
	MOV CL,byte ptr CS:[HighLights2+DI]
	MOV AX,0A0Ah
	call _Rect
	POP AX BX CX
	ret
endp


_ShowData proc
	;DX = marker

	;Clear Window ...
	
	MOV byte ptr CS:[narrow],1

	MOV AX,0
@@draw:
	MOV BX,2609h
	MOV CX,8040h
	PUSH AX
	MOV AX,0800h
	call _Rect
	POP Ax
	MOV word ptr CS:[cursor],270Ch

	@@next:
	MOV BX,AX
	SHL BX,1
	print VM_Offset

	CMP AX,DX
	JE @@ende
	MOV BX,word ptr CS:[DI]
	print VM_Value
	ADD DI,2
	INC AX


	CMP AX,DX
	JE @@ende

	MOV BX,CS:[DI]
	print VM_Value
	ADD DI,2
	INC AX

	MOV CX,word ptr CS:[Cursor]
	ADD CL,7
	MOV CH,27h
	MOV word ptr CS:[cursor],CX
	CMP CL,38h
	JB @@next

;NEW SCROLLER
	
	@@WaitLoop: 
		TestKey	KEY_Up
		JE @@up
		TestKey Key_Down
		JE @@down
		TestKey KEY_Left
	JNE @@WaitLoop		;WARNING! Interrupts are disabled to not interfere with keyboard and mouse handlers!
	
	
	MOV byte ptr CS:[narrow],0
	ret
@@return:	
	MOV byte ptr CS:[narrow],0

	ret
@@ende:
	MOV BX,word ptr CS:[DI]
	print VM_ValueMarked
	JMP @@return


@@down:
	SUB DI,24
	SUB AX,12
	JMP @@draw
@@up:
	SUB DI,32
	SUB AX,16
	CMP AX,0
	JL @@NoUp
	JMP @@draw
@@noUp:
	ADD AX,2
	ADD DI,4
	JMP @@draw
;END NEW


endp

_ShowDataSwap proc
	;DX = marker

	;Clear Window ...
	
	MOV byte ptr CS:[narrow],1

	MOV AX,0
@@draw:
	MOV BX,2609h
	MOV CX,8040h
	PUSH AX
	MOV AX,0800h
	call _Rect
	POP Ax
	MOV word ptr CS:[cursor],270Ch

	@@next:
	MOV BX,AX
	SHL BX,1
	print VM_Offset

	CMP AX,DX
	JE @@ende
	MOV BX,word ptr CS:[DI]
	XCHG BL,BH
	print VM_Value
	ADD DI,2
	INC AX


	CMP AX,DX
	JE @@ende

	MOV BX,CS:[DI]
	XCHG BL,BH
	print VM_Value
	ADD DI,2
	INC AX

	MOV CX,word ptr CS:[Cursor]
	ADD CL,7
	MOV CH,27h
	MOV word ptr CS:[cursor],CX
	CMP CL,38h
	JB @@next

;NEW SCROLLER
	
	@@WaitLoop: 
		TestKey	KEY_Up
		JE @@up
		TestKey Key_Down
		JE @@down
		TestKey KEY_Left
	JNE @@WaitLoop		;WARNING! Interrupts are disabled to not interfere with keyboard and mouse handlers!
	
	
	MOV byte ptr CS:[narrow],0
	ret
@@return:	
	MOV byte ptr CS:[narrow],0

	ret
@@ende:
	MOV BX,word ptr CS:[DI]
	print VM_ValueMarked
	JMP @@return


@@down:
	SUB DI,24
	SUB AX,12
	JMP @@draw
@@up:
	SUB DI,32
	SUB AX,16
	CMP AX,0
	JL @@NoUp
	JMP @@draw
@@noUp:
	ADD AX,2
	ADD DI,4
	JMP @@draw
;END NEW


endp


_debug_varsDS proc
	PUSHA

	MOV DI,word ptr CS:[vmDSBaseOff]
	MOV DX,word ptr CS:[vmESBaseOff]
	call _ShowData
	
	POPA
	ret
endp

_debug_varsES proc
	PUSHA

	MOV DI,word ptr CS:[vmESBaseOff]
	MOV DX,DI
	ADD DX,word ptr CS:[vmESLength]
	call _ShowData
	
	POPA
	ret
endp

_debug_varsSS proc
	PUSHA

	MOV DI,word ptr CS:[vmSSBaseOff]
	MOV DX,DI
	ADD DX,word ptr CS:[vmSSLength]
	call _ShowDataSwap
	
	POPA
	ret
endp


_debug_o_Stack proc
	PUSHA

	MOV DI,offset oStack	;StartOffset
	MOV DX,word ptr CS:[owPtr]
	call _ShowData

	POPA
	ret
endp

_debug_a_stack proc
	PUSHA

	MOV DI,offset aStack	;StartOffset
	MOV DX,word ptr CS:[awPtr]
	call _ShowData

	POPA
	ret
endp

_debug_program_source proc
	PUSHA


	MOV AX,offset BC_Target
	ADD AX,word ptr CS:[VMdsLength]
	ADD AX,7
	
	MOV DI,offset BC_Target
	MOV byte ptr CS:[narrow],1
	MOV byte ptr CS:[saveit],1
@@draw:
	MOV BX,2609h
	MOV CX,8040h

	PUSH AX
	MOV AX,0800h
	call _Rect
	POP AX

	MOV CS:[Cursor],0270Ch
	
	MOV DX,word ptr CS:[CurrentOffset]	;//Current offset of execution in program

	@@next:
	MOV BX,DI
	print VM_Offset

	MOV BL,byte ptr CS:[DI]
	CMP DI,DX
	JE @@highlight

	printCmd BL
	

   @@on: 
	INC DI
	CMP byte ptr CS:[SaveIt],1
	JNE @@noSave
		MOV word ptr CS:[saved],DI
		MOV byte ptr CS:[SaveIt],0
	@@noSave:

	MOV CX,word ptr CS:[Cursor]
	ADD CL,7
	MOV CH,27h
	MOV word ptr CS:[cursor],CX
	CMP CL,38h
	JB @@next

	MOV byte ptr CS:[SaveIt],1
	@@WaitLoop: 
;		TestKey	KEY_Up
;		JE @@up
		TestKey Key_Down
		JE @@down
		TestKey KEY_Left
	JNE @@WaitLoop		;WARNING! Interrupts are disabled to not interfere with keyboard and mouse handlers!
	
	
	MOV byte ptr CS:[narrow],0
	POPA
	ret

@@down:
	MOV CX,DI
	MOV DI,word ptr CS:[Saved]
	CMP DI,AX
	JA @@noDown
	JMP @@draw
@@noDown:
	MOV DI,CX
	JMP @@draw

@@highlight:
	print VM_ValueMarked1
	printCmd BL
	print VM_ValueMarked2

	JMP @@on		

	MOV byte ptr CS:[narrow],0
	POPA
	ret
endp

VM_Offset db '%h:',0
VM_Value db '%h ',0
VM_ValueMarked db '[%h]',0
VM_ValueMarked1 db '[',0
VM_ValueMarked2 db ']',0

Vm_DebugMenuText db '%sDebugger',0
vm_DebugoStack db '%8O-Stack',0
vm_DebugaStack db 'A-Stack',0
vm_DEbugProgram db 'Sources',0
vm_DebugVariablesDS db 'Seg DS',0
vm_DebugVariablesES db 'Seg ES',0
vm_DebugTrace db 'Seg SS',0
Vm_DebugExit db 'Exit',0
