;#All interpreter stuff (Stacks , pointers, variables)
include inc\interprt.msg	;Texts
include inc\interprt.mac	;MAcros


IF Memory_Method ne mmShared
	oStack db Operand_Stack_Size*2 dup (0)		;Operanden Stack
	aStack db Address_Stack_Size*2 dup (0)  	;Address Stack, size 
ELSE
	IF Memory_Method eq mmIndependant
		.err "Unknow memory method used!"
	ENDIF
ENDIF

oWPtr dw 0	;Pointer to next stack space to write to
aWPtr dw 0	;Pointer to next stack space to write to

HeadderString db 'MLCafxBC'


Poped db	'Poped: %n%r',0
dbgCS db	'Code Segment: %n%r',0
dbgDS db	'Data Segment: %n%r',0
dbgES db	'Extra Segment: %n%r',0
Terminated db 0	;Indicates program termination for the main loop 
vmReboot db 0
CurrentOffset dw 0

vmCSLength dw 0
vmDSLength dw 0
vmESLength dw 0
vmSSLength dw 0
vmVersionCheck dw 0
vmCSBaseSeg   dw 0
vmCSBaseOff   dw 0
vmDSBaseSeg   dw 0
vmDSBaseOff   dw 0
vmESBaseSeg   dw 0
vmESBaseOff   dw 0
vmSSBaseSeg   dw 0
vmSSBaseOff   dw 0

handlerTable dw 	offset _ADD	;Add command 	(000h)	-->DONE! (V 0.1)
	     dw		offset _SUB	;Sub command 	(001h)  -->DONE! (V 0.1)
	     dw		offset _NEG	;Neg command 	(002h) 	-->DONE! (v 0.3)

	     dw		offset _MUL	;Mul command 	(003h)	-->DONE! (V 0.1)
	     dw		offset _DIV	;Div command 	(004h)	-->DONE! (V 0.1)
	     dw		offset _MOD	;Mod command 	(005h)	-->DONE! (V 0.1)

	     dw		offset _CMPEQ	;Cmpeq command 	(006h)	-->DONE! (V 0.1)
	     dw		offset _CMPBL	;Cmpbl command 	(007h)	-->DONE! (V 0.1)
	     dw		offset _CMPAB	;Cmpab command 	(008h)	-->DONE! (V 0.1)
	     dw		offset _CMPNEQ	;Cmpneq command (009h)	-->DONE! (V 0.1)
	     dw		offset _CMPNBL	;Cmpnbl command (00Ah)	-->DONE! (V 0.1)
	     dw		offset _CMPNAB	;Cmpnab command (00Bh)	-->DONE! (V 0.1)

	     dw		offset _AND	;And command 	(00Ch)	-->DONE! (V 0.1)
	     dw		offset _OR 	;Or command 	(00Dh)	-->DONE! (V 0.1)
	     dw		offset _NOT	;Not command 	(00Eh)	-->DONE! (V 0.1)
	     dw		offset _SHL	;Shl command 	(00Fh)	-->DONE! (V 0.1)
	     dw 	offset _SHR	;SHR command 	(010h)	-->DONE! (V 0.1)

	     dw		offset _CCST	;CCST command 	(011h)	-->DONE! (v 0.3)
	     dw		offset _I2S	;I2S=CSTR cmd 	(012h)  -->DONE! (v 0.3)
	     dw		offset _S2I	;S2I command 	(013h)

	     dw		offset _GETCH	;Getch command 	(014h)
	     dw		offset _SETCH	;Setch command 	(015h)

;MLC2 Commands
	     dw		offset _TEXTM 	;Text command 	(016h) 	-->DONE! (v 0.1)
	     dw		offset _DBMP	;Cmpbl command 	(017h)
	     dw		offset _PIXL	;Pixl command 	(018h)	-->DONE! (V 0.3)
	     dw		offset _PIXT	;Cmpneq command (019h)  -->Partiall in (v 0.3)
	     dw		offset _LINEM	;Line command 	(01Ah)	-->DONE! (V 0.3)
	     dw		offset _PAUS	;PAUS command 	(01Bh)	-->DONE! (v 0.1)
	     dw		offset _SIZE	;And command 	(01Ch)
	     dw		offset _CLSN 	;Or command 	(01Dh)
	     dw		offset _CLRS	;CLRS command	(01Eh)	-->DONE! (V 0.1)
	     dw		offset _DISP	;Shl command 	(01Fh)  -->DONE! (v 0.1)
	     dw 	offset _GKEY	;SHR command 	(020h)
	     dw		offset _WKEY	;CCST command 	(021h)	-->DONE! (v 0.3)
	     dw		offset _WAIT	;I2S command 	(022h)	-->DONE! (v 0.3)
	     dw		offset _SHFT	;S2I command 	(023h)
	     dw		offset _RECTM	;Rect command 	(024h)	-->DONE! (V 0.3)

	     dw		offset _JMPi8	;JMPI8 command 	(025h)
	     dw		offset _JMPi16 	;Text command 	(026h)
	     dw		offset _JMPm8	;Cmpbl command 	(027h)
	     dw		offset _JMPm16	;Cmpab command 	(028h)

	     dw		offset _JCCi8	;Cmpneq command (029h)
	     dw		offset _JCCi16	;JMP if S[0]=0  (02Ah)
	     dw		offset _JCCm8	;Cmpnab command (02Bh)
	     dw		offset _JCCm16	;And command 	(02Ch)

	     dw		offset _CALLi8 	;Or command 	(02Dh)
	     dw		offset _CALLi16	;Not command 	(02Eh)
	     dw		offset _CALLm8	;Shl command 	(02Fh)
	     dw 	offset _CALLm16	;SHR command 	(030h)

	     dw		offset _HALT	;I2S command 	(031h)	--> DONE!(Engine, V 0.1)

	     dw		offset _RSTA	;S2I command 	(032h)
	     dw		offset _RSTO	;Getch command 	(033h)

	     dw		offset _PUSHi16	;Getch command 	(034h)	--> DONE! (v 0.1)
	     dw		offset _PUSHm8	;JMPI8 command 	(035h)  --> DONE! (V 0.1)
	     dw		offset _PUSHm16	;Text command 	(036h)  --> DONE! (V 0.1)

	     dw		offset _PUSHPm8	;Cmpbl command 	(037h) 	
	     dw		offset _PUSHPm16;Cmpab command 	(038h)	

	     dw		offset _DECSP	;Cmpneq command (039h)  --> DONE! (V 0.1)
	     dw		offset _POPm8	;Cmpnbl command (03Ah)	--> DONE! (v 0.1)
	     dw		offset _POPm16	;Cmpnab command (03Bh)	--> DONE! (v 0.1)
	     dw		offset _POPPm8	;And command 	(03Ch)
	     dw		offset _POPPm16	;Or command 	(03Dh)
	     dw		offset _MOVm8	;Not command 	(03Eh)
	     dw		offset _MOVm16	;Shl command 	(03Fh)
	     dw 	offset _MOVpm8	;SHR command 	(040h)
	     dw		offset _MOVpm16	;I2S command 	(041h)
	     dw    	offset _reti8	;reti8 command	(042h)	;--> Partial implemented in V 0.2

;Mouse commands
	     dw 	offset _mousefunction	;MFNC command  (043h)
	     dw 	offset _mouseon		;MSET command  (044h)
;Extended Commands (since version 0.3)
	     dw 	offset _LDS		;Function to load values from stack and push them (045h)again. 	     
	     dw		offset _BREG		;Register a button to the mouse handler (046h)
	     dw		offset _MOFF		;Exit the mouse (047h)
	     dw		offset _DBG		;Starte Debugger (048h)
	     dw 	offset _CSC		;Create String Copy (049h)
  	     dw		offset _POPmES16	;write to 16 bit ES  (04Ah)
	     dw		offset _UNUSED		;Create String Instance (without deleting old) (04Bh)
	     dw		offset _CSTR		;Clear String (04Ch)

_UNUSED proc
	ret
endp

_CSTR proc
	PUSH AX CX DS
	LODSW
	PUSH SI
	MOV CX,AX
	call _CLRSTR
	POP SI DS CX AX
	ret
endp

_CLRSTR_TMP proc
	PUSH AX
	XOR AX,AX
	call _PushOperand
	call _CLRSTR
	call _PopRegister
	POP AX
	ret
endp

_CLRSTR proc
	PUSH AX BX CX DX DS SI ES DI
	;ES[AX]
	LOADBASE_ES
	ADD SI,CX
	LODSW

	CMP AX,0
	JE @@done
	
	MOV BX,AX
	LOADBASE_SS
	ADD SI,AX		;String to clear at SS[AX]

	PUSH DS SI
	POP DI ES		;Prepare for write down
	XOR DX,DX
	@@looper1:
		INC DX
		LODSB
		CMP AL,0
	JNE @@looper1


	MOV CX,word ptr CS:[vmSSLength]
	SUB CX,BX
	REP MOVSB

	LOADBASE_ES


	XOR CX,CX

	@@looper2:
		CMP word ptr DS:[SI],BX


		JNA @@no_correct
			SUB word ptr DS:[SI],DX
		@@no_correct:
		ADD SI,2
		ADD CX,2
		CMP CX,word ptr CS:[vmESLength]
 		JB @@looper2
	call _popRegister
	CMP AX,BX
	JNA @@no_correct2
		SUB AX,DX
;		MOV BX,AX
;		print number
;		waitforanykey
	@@no_correct2:
	call _PushOperand
	SUB word ptr CS:[vmSSLength],DX
	@@done: POP DI ES SI DS DX CX BX AX
	ret
endp

_CSC proc
	PUSH DS ES DI SI BX AX  CX
	CALL _popRegister	;->AX
	MOV CX,AX
	LOADBASE_ES
	ADD SI,AX
	LODSW			;SS[AX]
	
	LOADBASE_SS
	PUSH DS SI
	POP DI ES		
	ADD SI,AX
	ADD DI,word ptr CS:[vmSSLength]
	MOV BX,0
	@@looper:
		INC BX
		LODSB
		STOSB
		CMP AL,0
		JNE @@looper

	
	MOV AX,word ptr CS:[vmSSLength]
	call _PushOperand	;Write the new string to stack ...
	ADD word ptr CS:[vmSSLength],BX	;Correct the SS Length	
	@@ende:
	POP CX AX BX SI DI ES DS
	ret	;//TODO!
endp


_MOFF proc
	call _DrawMouse
	MOV byte ptr CS:[MouseEnabled],No
	MOV word ptr CS:[Keyboard_Handler],offset _kbd_stub
	ret
endp

_DBG proc
	call invoke_debugger
	ret
endp

_BREG proc
	;REgister Button
	PUSH DS SI AX BX CX DX DI
	LoadBASE_DS
	call _PopRegister
	ADD SI,AX	;SI = Pointer to 
	MOV DI,word ptr CS:[Button_Counter]
	MOV word ptr DS:[SI],DI
	POPRegister DX		;--> y2
	POPRegister CX		;--> x2
	POPRegister BX		;--> y1
	PUSH seg Button_Table
	POP DS
	MOV SI,offset Button_Table
	MOV AX,word ptr CS:[Button_Counter]
	SHL AX,3		;x8
	ADD Si,AX
	call _PopRegister	;AX --> x1
	MOV byte ptr DS:[SI],AL
	MOV byte ptr DS:[SI+1],BL
	MOV byte ptr DS:[SI+2],CL
	MOV byte ptr DS:[SI+3],DL
	MOV byte ptr DS:[SI+4],1
	ADD SI,6
	MOV word ptr DS:[SI],DI
	INC word ptr CS:[Button_Counter]

	POP DI DX CX BX AX SI DS	
	ret
endp

;New Comands ...

_ADD proc
	PUSH BX AX
	call _popregister	;AX

	POPRegister BX

	ADD AX,BX
	JO @@add_to_big
	CMP AX,0111111111111111b
	JA @@add_to_big
	
;	Into	;//Check overflow and do INT4 if yes
	
	call _PushOperand

	POP ax BX
	ret
	@@add_to_big: 
		errormsg Number	;//TODO! Change to appropriate message
endp

_SUB proc
	PUSH BX AX

	PopRegister BX
	call _POPRegister	;AX
	SUB AX,BX
	Into	;//Check overflow and do INT4 if yes
	call _PushOperand
	POP AX BX
	ret
endp

_NEG proc
	PUSH AX
	call _PopRegister	;AX
	NEG AX
	call _PushOperand
	POP AX
	ret
endp

_MUL proc
	PUSH AX BX DX
	call _PopRegister	;AX
	PopRegister BX
	MUL BX			;Result in DX:AX
	Into	;//Check overflow and do INT4 if yes
	CMP DX,0
	JNE @@TooBig
	call _PushOperand
	POP DX BX AX
	ret
	@@TooBig:
		errorMSG RTE_TooBig
endp

_DIV proc
	PUSH BX AX DX

	PopRegister BX
	call _PopRegister	;AX

	XOR DX,DX
	CMP BX,0
	JE @@div_by_zero
	DIV BX
	Into	;//Check overflow and do INT4 if yes
	call _PushOperand
	POP DX AX BX
	ret
	@@div_By_Zero:
		errorMsg RTE_DBZ
endp

_MOD proc
	PUSH BX AX DX

	PopRegister BX
	call _PopRegister	;AX

	XOR DX,DX
	CMP BX,0
	JE @@div_by_zero
	DIV BX
	Into	;//Check overflow and do INT4 if yes
	MOV AX,DX		;DX = rest
	call _PushOperand
	POP DX AX BX
	ret
	@@div_By_Zero:
		errorMsg RTE_DBZ
	ret
endp

_CMPEQ proc
	PUSH AX BX
	PopRegister BX
	call _PopRegister
	CMP AX,BX
	JE @@eq
	XOR AX,AX
	call _PushOperand
	JMP @@done
      @@eq:
	MOV AX,1
	call _PushOperand
      @@done:
	POP BX AX
	ret
endp

_CMPBL proc
	PUSH AX BX

;Verbose compare:

;	MOV BX,word ptr CS:[owPtr]
;	print number
;	WaitForAnyKey

	PopRegister BX
	call _PopRegister

	CMP BX,AX
	JB @@below
	XOR AX,AX
	call _PushOperand
	JMP @@done
      @@below:
	MOV AX,1
	call _PushOperand
      @@done:
	POP BX AX
	ret
endp

_CMPAB proc
	PUSH AX BX
	PopRegister BX
	call _PopRegister
	CMP AX,BX
	JA @@above
	XOR AX,AX
	call _PushOperand
	JMP @@done
      @@above:
	MOV AX,1
	call _PushOperand
      @@done:
	POP BX AX
	ret
endp

_CMPNEQ proc
	PUSH AX BX
	PopRegister BX
	call _PopRegister
	CMP AX,BX
	JNE @@neq
	XOR AX,AX
	call _PushOperand
	JMP @@done
      @@neq:
	MOV AX,1
	call _PushOperand
      @@done:
	POP BX AX
	ret
endp

_CMPNBL proc
	PUSH AX BX
	PopRegister BX
	call _PopRegister
	CMP AX,BX
	JAE @@above_equal
	XOR AX,AX
	call _PushOperand
	JMP @@done
      @@above_equal:
	MOV AX,1
	call _PushOperand
      @@done:
	POP BX AX
	ret
endp

_CMPNAB proc
	PUSH AX BX
	PopRegister BX
	call _PopRegister
	CMP AX,BX
	JBE @@below_equal
	XOR AX,AX
	call _PushOperand
	JMP @@done
      @@below_equal:
	MOV AX,1
	call _PushOperand
      @@done:
	POP BX AX
	ret
endp

_AND proc
	PUSH AX BX
	PopRegister BX
	call _PopRegister
	AND AX,BX
	call _PushOperand
	POP BX AX
	ret
endp

_OR proc
	PUSH AX BX
	PopRegister BX
	call _PopRegister
	OR AX,BX
	call _PushOperand
	POP BX AX
	ret
endp

_NOT proc
	PUSH AX
	call _PopRegister
	NOT AX
	call _PushOperand
	POP AX
	ret
endp

_SHL proc
	PUSH AX CX
	PopRegister CX
	call _PopRegister
	CMP CH,0
	JNE @@shift_error
	SHL AX,CL
	call _PushOperand
	POP BX AX
	ret
	@@shift_error:
	ErrorMSG SHiftLarge
endp

_SHR proc
	PUSH AX CX
	PopRegister CX
	call _PopRegister
	CMP CH,0
	JNE @@shift_error
	SHR AX,CL
	call _PushOperand
	POP BX AX
	ret
	@@shift_error:
	ErrorMSG SHiftLarge
endp	

_CCST proc
	;Concatentate string (sp?) ... however ... join 2 strings ;) ... 

;New, greatly simplified CSC ...

	PUSH AX BX CX ES DI DS SI

	call _PopRegister	;->AX (Str2)
	PopRegister BX		;->BX (Str1)
	call _PushOperand	;-> Push Str2 again
	MOV CX,AX		;->CX (Str2)
	
	MOV AX,BX		;->AX (Str1)
	call _PushOperand	;Order is ok -> (Str1)

	MOV CX,0
	call _CLRSTR		;Clear old temporary string (at 0 in String Table ES)

	MOV BX,CS:[vmSSLength]

	call _CSC	;Copy first string to  end ...
	DEC word ptr CS:[vmSSLength]	;remove the ending sign ...
	call _PopRegister	;"Fake pop" this must be kept for the final push!
	call _CSC
	CALL _PopRegister

	

	LOADBASE_ES
	MOV word ptr DS:[SI],BX

	XOR AX,AX
	call _PushOperand
	;DONE!

	
	POP SI DS DI ES CX BX AX
	ret
	
endp

defrag db '%sDEFRAGMENTER',0
info	db '%8Memory ...',0

_defrag_mem proc
	PUSH DX BX CX AX SI DS DI ES

	MOV AX,01A20h
	MOV ES,AX
	MOV DS,AX

	XOR SI,SI
	MOV DI,1024*4	;4 Pages --> next 4 pages
	MOV CX,1024*2
	REP MOVSW

	;PauseBox
	MOV BX,201Ah
	MOV CX,602Ah
	MOV AX,0800h
	call _Rect

	ADD BX,0101h
	MOV CX,5F22h
	MOV AX,0808h
	call _Rect

	MOV byte ptr CS:[narrow],1
	MOV word ptr CS:[Cursor],211Ah
	print defrag
	MOV byte ptr CS:[narrow],1
	MOV word ptr CS:[Cursor],2123h
	print info
	waitforanykey

	LOADBase_ES
	@@looper:
		PUSH DS SI
		MOV AX,SI
		LOADBase_DS ;!!TODO! Can not identify strings! They might as well be integers...
		MOV BX,10
		@@innerLooper:
			CMP word ptr DS:[SI+BX],AX
			JE @@found
			ADD BX,2
			CMP BX,word ptr DS:[vmDSLength]
			JAE @@innerLooper
		;//Not Found!
		;Remove string ..
		POP SI DS
		
		@@found:
		POP SI DS
	loop @@looper

	MOV AX,01A20h
	MOV ES,AX
	MOV DS,AX

	XOR DI,DI
	MOV SI,1024*4	;4 Pages --> next 4 pages
	MOV CX,1024*2
	REP MOVSW

	POP ES DI DS SI AX CX BX DX
	ret
endp

_i2s proc
	PUSH CX DX AX BX DS SI ES DI 
	call _POPRegister	;String position in AX
PUSH AX
;	MOV BX,word ptr CS:[vmESLength]
;	print number
;waitforanykey


	PopRegister BX		;Number in BX
	MOV CX,AX
	call _CLRSTR_TMP




	;Create new string object ...
	LOADBase_SS
	ADD SI,word ptr CS:[vmSSLength]

	PUSH DS SI
	POP DI ES	

	xor si,SI

	CMP BX,0F001h
	

;	JA @@no_minus
;		INC SI
;		MOV AL,'-'
;		STOSB
;		db 00Fh,01Fh,0C3h,0Fh	;Not1 BX,15
;	@@no_minus:
	

	CMP BX,9999
	JA @@print5
	CMP BX,999
	JA @@print4
	CMP BX,99
	JA @@print3
	CMP BX,9
	JA @@print2
	JMP @@print1
	@@print5:
		INC SI
		MOV AX,BX
		MOV BX,10000
		XOR DX,DX
		DIV BX
		MOV BX,DX
		add AL,48
		STOSB
	@@print4:
		INC SI
		MOV AX,BX
		MOV BX,1000
		XOR DX,DX
		DIV BX
		MOV BX,DX
		add AL,48
		STOSB
	@@print3:
		INC SI
		MOV AX,BX
		MOV BX,100
		XOR DX,DX
		DIV BX
		MOV BX,DX
		add AL,48
		STOSB
	@@print2:
		INC SI
		XOR Ax,AX
		MOV AL,BL
		MOV BH,10
		DIV BH
		MOV BL,AH
		add AL,48
		STOSB
	@@print1:
		INC SI
		MOV AL,BL
		ADD AL,48
		STOSB
@@ende:		
	XOR AX,AX
	STOSB
	MOV BX,SI		;Length of String in BX
	INC BX
	LOADBASE_ES

	POP CX

	ADD SI,CX
	MOV AX,word ptr CS:[vmSSLength]
	MOV word ptr DS:[SI],AX
	ADD word ptr CS:[vmSSLength],BX
	

@@REAlend:	POP DI ES SI DS BX AX DX CX
	ret
@@cluttered_debug:	;//In future the garbage collector will be placed here. The same mechanism has to be implemented for I2S!
;Collecting Garbage ...

	call _defrag_mem
	JMP @@realend
endp

_s2i proc
	ret
endp

_getch proc
	ret
endp

_setch proc
	ret
endp

_TEXTM proc
	PUSH BX AX DS SI
	call _drawMouse
	call _PopRegister	;POP to AX ONLY(!!!) over this command. POPRegister Macro not possible!
	
	LoadBASE_ES
	ADD SI,AX

	LODSW
	LoadBASE_SS
	ADD SI,AX
	
	
	call _PopRegister
	POPRegister BX
	MOV AH,BL
	MOV word ptr CS:[cursor],AX


	call _Print

	call _drawMouse
	@@ende: POP SI DS AX BX
	ret
endp

_DBMP proc
	ret
endp

_PIXL proc
	PUSH AX BX DX
	call _drawMouse

	call _PopRegister	;Color in AX
	PopRegister BX		;y
	POPRegister DX		;x = DL
	MOV DH,BL

	call _SetPixel		;Write the pixel ...
	
	call _drawMouse
	POP DX BX AX
	ret
endp

_PIXT proc
	ret
endp

_LINEM proc
	PUSH BX CX AX
	call _drawMouse
		call _PopRegister
		PUSH AX
		call _PopRegister
		MOV CL,AL
		call _PopRegister
		MOV CH,AL
		call _PopRegister
		MOV BL,AL
		call _PopRegister
		MOV BH,AL
		POP AX
		XCHG AH,AL
		call _Line		
	call _drawMouse
	POP AX CX BX	
	ret
endp

_PAUS proc
	WaitForAnyKey
	ret
endp

_SIZE proc
	ret
endp

_CLSN proc
	ret
endp

_CLRS proc
	call _CLS
	ret
endp

_DISP proc
	call _CopyBuffer
	ret
endp

_GKEY proc
	ret
endp

_WKEY proc
	ret
endp

_WAIT proc
	PUSH AX
	call _popRegister
	
	delay AX
	POP AX
	ret
endp

_SHFT proc
	ret
endp

_RECTM proc
	call _drawMouse
	PUSH BX CX AX
		call _PopRegister	;Fill Color
		MOV CL,AL
		call _PopRegister	;Line Color
		MOV AH,AL
		MOV AL,CL
		PUSH AX
		call _PopRegister	;y1
		MOV CL,AL
		call _PopRegister	;x1
		MOV CH,AL
		call _PopRegister	;y0
		MOV BL,AL
		call _PopRegister	;x0
		MOV BH,AL
		POP AX
		call _Rect
	POP AX CX BX	
	call _drawMouse
	ret
endp

_JMPi8 proc
	ret
endp

_JMPi16 proc
	ret
endp

_JMPm8 proc
	ret
endp

_JMPm16 proc
	ret
endp

_JCCi8 proc
	ret
endp

_JCCi16 proc	;Syntax: JCC Yes/No,Target
	PUSH AX BX
	POPRegister BX	;This writes the SI register ... 
	call _PopRegister
	CMP AX,0
	JNE @@ende
	MOV SI,BX
	ADD SI,word ptr CS:[vmCSBaseOff]
	@@ende: POP BX AX
	ret
endp

_JCCm8 proc
	ret
endp

_JCCm16 proc
	ret
endp

_calli8 proc
	ret
endp

_CALLi16 proc
	;Preserve SI for the RET
	PUSH BX
	MOV BX,word ptr CS:[awPtr]
	CMP BX,Address_Stack_Size
	JAE @@noMoreRegression
	ADD BX,offset cs:[aStack]
	MOV word ptr CS:[BX],SI
	ADD word ptr cs:[awPtr],2
	POP BX

	CLI		;This critical since it could jump to invalid code! keep in any case!
	POPRegister SI	;This writes the SI register ... 
	ADD SI,word ptr CS:[vmCSBaseOff]
	STI
	
	ret
	@@noMoreRegression:
		errorMSG aStack_Overflow
endp

_CALLm8 proc
	ret
endp

_CALLm16 proc
	ret
endp

_reti8 proc
	;Change this
	CMP word ptr CS:[awPtr],2
	JB @@end_halt
	SUB word ptr CS:[awPtr],2
	PUSH BX
	MOV BX,word ptr CS:[awPtr]
	ADD BX,offset aStack
	MOV SI,word ptr CS:[BX]		;REstore old ptr.
	POP BX	
	ret
	@@end_halt:
;		errorMSG astack_Underflow
		MOV byte ptr CS:[Terminated],1
		ret
endp

_HALT proc
	MOV byte ptr CS:[Terminated],1
	ret
endp

_RSTA proc
	ret
endp

_RSTO proc
	ret
endp

_PUSHi16 proc
	PUSH AX
	LODSW
	call _PushOperand
	POP AX
	ret
endp

_PUSHm8 proc
	PUSH AX DS
	XOR AX,AX
	LODSB			;Read the position in mem from the BC
	PUSH SI
	LOADBase_DS
	ADD SI,AX		;Point to VM DS
	MOV AX,word ptr DS:[SI]	;And read the value.
	call _PushOperand  	;Push the value to the stack ..
	POP SI DS AX
	ret
endp

_PUSHm16 proc 
	PUSH AX DS
	LODSW			;Read the position in mem from the BC
	PUSH SI
	LOADBase_DS
	ADD SI,AX		;Point to VM DS
	MOV AX,word ptr DS:[SI]	;And read the value.
	call _PushOperand  	;Push the value to the stack ..
	POP SI DS AX
	ret
endp

_PUSHPm8 proc
	ret
endp

_PUSHPm16 proc
	ret
endp

_DECSP proc
	PUSH BX AX
	call _PopREgister
	POP AX BX
	ret
endp

_POPm8 proc
	PUSH BX AX DS
	XOR AX,AX
	PopRegister BX  ;Load the word to write from the stack ..
	LODSB		;Load the memory address
	PUSH SI
	LOADBase_DS	;Load the Data segment to DS:SI
	ADD SI,AX	;ADjust correct address
	MOV word ptr DS:[SI],BX	;Written!
	POP SI DS AX BX
	ret
endp

_POPm16 proc
	PUSH BX AX DS SI
	PopRegister BX  ;Load the word to write from the stack ..
	LODSW		;Load the memory address
	LOADBase_DS	;Load the Data segment to DS:SI
	ADD SI,AX	;ADjust correct address
	MOV word ptr DS:[SI],BX	;Written!
	POP SI DS AX BX
	ADD SI,2
	ret
endp

_POPmES16 proc
	PUSH BX AX DS SI
	PopRegister BX  ;Load the word to write from the stack ..
	LODSW		;Load the memory address
	LOADBase_ES	;Load the Data segment to ES:SI
	ADD SI,AX	;ADjust correct address
	MOV word ptr DS:[SI],BX	;Written!
	POP SI DS AX BX
	ADD SI,2
	ret
endp


_POPPm8 proc
	ret
endp

_POPPm16 proc
	ret
endp

_MOVm8 proc
	ret
endp

_MOVm16 proc
	ret
endp

_MOVPm8 proc
	ret
endp

_MOVPm16 proc
	ret
endp

_mousefunction proc
	PUSH AX
	call _PopRegister
	MOV word ptr CS:[mouse_handler],AX	;This is the address of the mouse handler function
	POP AX
	ret
endp

_mouseon proc
	MOV byte ptr CS:[MouseEnabled],Yes
	MOV word ptr CS:[Keyboard_Handler],offset _Keyboard_mouse
	call _drawMouse
	ret
endp


_Pushi8 proc
	PUSH AX
	AND AX,07Fh
	call _PushOperand
	POP AX
	ret
endp


_LDS proc
	;loads 1 parameter from stack (number in next byte) and pushes it again. 0 = last pushed element so. LDS 0 --> last value put on stack again
	PUSH AX DI
	XOR AH,AH
	LODSB	;Load 1 byte that indicates the stack value that should be pushed again.
	MOV DI,word ptr CS:[owPtr]


	SUB DI,AX
	DEC DI
	SHL DI,1
	ADD DI,offset CS:[oStack]
	MOV AX,word ptr CS:[DI]

;	PUSH BX
;	MOV BX,AX
;	print Number
;	WaitForAnyKey
;	POP BX


	call _PushOperand
	POP DI AX
	ret
endp

_execute proc
	;Byte to execute in AL ;!! DO NOT CHAGE DS:SI! NEVER!!!
	PUSH BX
		MOV BL,AL
		XOR BH,BH
		SHL BX,1
		call word ptr CS:[offset handlerTable+BX]
	POP BX
	CMP byte ptr CS:[Mouse_Interrupt],1
	JNE @@ende
	;Test if valid button
	PUSH DS SI AX
	PUSH seg Button_Table
	POP DS
	MOV SI,offset Button_Table
@@test_next:
	CMP byte ptr DS:[SI+4],0
	JE @@ende2
;	MOV BX,SI
;	errorMSG number
	LODSB
	CMP AL,byte ptr CS:[MousePosition_x]
	JNB @@testNext1
	LODSB
	CMP AL,byte ptr CS:[MousePosition_y]
	JNB @@testNext2
	LODSB
	CMP AL,byte ptr CS:[MousePosition_x]
	JNA @@testNext3
	LODSB
	CMP AL,byte ptr CS:[MousePosition_y]
	JNA @@testNext4
	LODSB
	CMP AL,1
	JNE @@ende2
	LODSB
	LODSW		;//TODO! Call the function with THIS parameter. This is the mouseevent handled
	POP AX SI DS

	PUSH AX
	MOV AX,word ptr CS:[Mouse_Handler]
	call _PushOperand
	call _calli16
	POP AX
	@@ende: MOV byte ptr CS:[Mouse_Interrupt],0
	ret
	@@ende2: POP AX SI DS
	JMP @@ende

	@@testNext1:
		INC SI
	@@testNext2:
		INC SI
	@@testNext3:
		INC SI
	@@testNext4:
		ADD SI,4
	JMP @@test_next

endp


_PushOperand proc
	;Operand to push in AX
	PUSH BX				;Presave BX

	CMP word ptr CS:[oWPtr],Operand_Stack_Size*2	;If we have 256 words on the stack then 
	JE @@error			;Print error and exit
	MOV BX,word ptr CS:[owPtr]		;else load stack pointer
	SHL BX,1			;adjust to WordStack and ... AX
	ADD BX,offset CS:[oStack]
	MOV word ptr CS:[BX],AX	;is on stack!
	INC word ptr CS:[oWPtr]		;Point to nex element
	POP BX				;Restore registers and return

	ret
	@@error:
	ErrorMSG StackError_msg
endp

_Error proc
	;Errorhandling here!
	PUSH CS
	POP DS
;	InitText
	call _Print

	MOV BX,word ptr CS:[CurrentOffset]
	print number

	delay 20
	WaitForAnyKey
	call invoke_debugger

	

	If Instant_Exit eq No
		DebugApplication
		ELSE
		IF Instant_Exit ne Yes
			.ERR "Wrong Value For Instant_Exit!"
		ENDIF
	ENDIF

	InitText
	ResetTimer
	ResetKeyboard
	
	
	MOV AX,04C00h	;Terminate execution and return to DOS/CasioMenu
	INT 21h
endp

_PopRegister proc
	;return Register in AX
	PUSH BX

	CMP word ptr CS:[owPtr],0
	JE @@noPopError
	DEC word ptr CS:[owPtr]
	MOV BX,word ptr CS:[owPtr]
	SHL BX,1
	ADD BX,offset CS:[oStack]
	MOV AX,word ptr cs:[BX]
	POP BX
	ret
	@@noPopError:
	ErrorMSG StackNoPop
endp

_CopyBuffer proc	;Copy buffers 4-7 to 0-3
	PUSh ES DS SI DI CX

	XOR DI,DI
	MOV SI,01A20h
	MOV ES,SI
	MOV DS,SI
	MOV SI,1024*3
	MOV CX,512*4
	REP MOVSW
	
	POP CX DI SI DS ES
	ret
endp

_Run proc
	;DS:SI is the address of the bytecode to run
	PUSH AX ES DI CX BX
	PUSH DS SI
	@@restart:
		POP SI DS
		PUSH DS SI
		MOV CS:[vmReboot],0
	PUSH CS
	POP ES
	MOV DI,offset HeadderString
	MOV CX,8
	REPE CMPSB		;Compare the headder with the memory 
	CMP CX,0		;If not equal
	JE @@headder_ok		;then display error and exit
		JMP @@error_headder
	@@headder_ok:
	LODSW
	MOV CS:[vmCSLength],AX


	LODSW
	MOV CS:[vmDSLength],AX

	LODSW
	MOV CS:[vmESLength],AX

	LODSW
	MOV CS:[vmSSLength],AX

	LODSW		;//TODO! Version Check
	MOV CS:[vmVersionCheck],AX

	MOV word ptr CS:[vmCSBaseSeg],DS
	MOV word ptr CS:[vmCSBaseOff],SI

	MOV word ptr CS:[vmDSBaseSeg],DS
	MOV DI,SI
	ADD DI,word ptr CS:[vmCSLength]
	ADD word ptr CS:[vmDSBaseOff],DI

	MOV word ptr CS:[vmESBaseSeg],DS
	ADD DI,CS:[vmDSLength]
	MOV word ptr CS:[vmESBaseOff],DI

	MOV word ptr CS:[vmSSBaseSeg],DS
	MOV BX,word ptr CS:[vmESLength]
	SHL BX,1
	ADD DI,BX
;	MOV BX,DI
;	print number
;	waitforanykey
	MOV word ptr CS:[vmSSBaseOff],DI
	
	
	LoadBASE_DS	;Load data nach DS:SI
	LODSW
	LoadBASE_CS
	ADD SI,AX	;adjust program start address in code segment

		;Now we are at the start of the code segment.
	MOV byte ptr CS:[Terminated],0
	@@interprete:
	  LODSB
	  MOV word ptr CS:[CurrentOffset],SI   
	  CMP AL,031h
	  JE @@ende

	  MOV CL,AL		;Fix with native code (TestBit 8)
	  AND CL,080h
	  CMP CL,080h
	  JE @@do_pushi8

	  call _execute
	  CMP byte ptr CS:[Terminated],1
	  JE @@ende
	  CMP byte ptr CS:[VMREboot],1
	  JNE @@interprete
	  JMP @@restart
	@@do_pushi8:
		call _PushI8
		JMP @@interprete
	@@error_headder:
		ErrorMSG noHeadder_msg
	@@ende:	
;		InitText
;		XOR BX,BX
;		Print Terminate
	POP SI DS BX CX DI ES AX
	ret
endp