include inc\Keyboard.mac

oldISR_Kbd_off dw 0
oldISR_Kbd_Seg dw 0

KeyPressed db 0

KeyBoard_Handler dw offset _KBD_Stub

Yes equ 1
No equ 0

_KBD_Stub proc 
	ret
endp

_WaitFOrAnyKey proc
	MOV CS:[KeyPressed],NO
	@@test: CMP CS:[KeyPressed],YES
	JNE @@test
	@@test2:
		CMP CS:[KeyPressed],NO
		MOV CS:[KeyPressed],No
		JNE @@test2
	ret
endp

_SetupKeyboard proc
	PUSH AX ES
	
	CLI
	XOR AX,AX
	PUSH AX
	POP ES
	MOV AX,word ptr ES:[09h*4]
	MOV word ptr CS:[oldISR_kbd_off],AX	
	MOV word ptr ES:[09h*4],offset __KeyboardISR
	
	MOV AX,word ptr ES:[09h*4+2]
	MOV word ptr CS:[oldISR_kbd_seg],AX
	MOV word ptr ES:[09h*4+2],seg __KeyboardISR
	
	STI

	POP ES AX
	ret
endp

_ResetKeyboard proc
	PUSH AX ES
	
	CLI
	XOR AX,AX
	PUSH AX
	POP ES
	MOV AX,word ptr CS:[oldISR_kbd_off]
	MOV word ptr ES:[09h*4],AX
	
	MOV AX,word ptr CS:[oldISR_kbd_seg]
	MOV word ptr ES:[09h*4+2],AX
	
	STI

	POP ES AX
	ret
endp

__KeyboardISR proc	;Need to change this! The keyboard must be queried for keydown and keyup ...
	PUSH SI
	MOV CS:[keyPressed],Yes
	MOV SI,offset CS:[Keyboard_Handler]
	CLI
	call word ptr CS:[SI]

	TESTKey KEY_On
	JE @@DisplayMenu

@@return: STI
	POP SI
	iret
	@@DisplayMenu:
		call _InterruptMenu	
		JMP @@return
		
endp

_TestKey proc
	;IN: Si = Offset of Key
	;Out: ZF=0 --> Not pressed / ZF=1 --> Pressed
	PUSH AX
	MOV AX,word ptr CS:[SI]
	OUT 013h,AX
	IN AL,013h
	ADD SI,2
	CMP AL,byte ptr CS:[SI]
	POP AX
	ret
endp

;first2 value = line, third = col
KeyTable:
	Key_0 db 2,0,64
	Key_Dot db 2,0,32
	Key_x10 db 2,0,16
	Key_PMinus db 2,0,8
	Key_EXE db 2,0,4
	Key_1 db 4,0,64
	Key_2 db 4,0,32
	Key_3 db 4,0,16
	Key_Plus db 4,0,8
	Key_Minus db 4,0,4
	Key_4 	db 8,0,64
	Key_5	db 8,0,32
	Key_6	db 8,0,16
	Key_Mul	db 8,0,8
	Key_Div	db 8,0,4
	Key_7 	db 16,0,64
	Key_8 	db 16,0,32
	Key_9 	db 16,0,16
	Key_DEL db 16,0,8
	Key_ABC db 32,0,64
	Key_xy 	db 32,0,32
	Key_BOpen db 32,0,16
	Key_BClose db 32,0,8
	Key_Comma db 32,0,4
	Key_What db 32,0,2
	Key_X db 64,0,64
	Key_Log db 64,0,32
	Key_ln db 64,0,16
	Key_sin db 64,0,8
	Key_cos db 64,0,4
	Key_tan db 64,0,2
	Key_Alpha db 128,0,64
	Key_Vars db 128,0,32
	Key_Exp db 128,0,16
	Key_Esc db 128,0,8
	Key_Shift db 0,1,64
	Key_CTRL db 0,1,32
	Key_Optn db 0,1,16
	Key_Menu db 0,1,8
	Key_Left db 0,2,64
	Key_Up db 0,2,32
	Key_Down db 0,2,16
	Key_Right db 0,2,8
	Key_F1 db 0,4,64
	Key_F2 db 0,4,32
	Key_F3 db 0,4,16
	Key_F4 db 0,4,8
	Key_F5 db 0,4,4
	Key_F6 db 0,4,2
	Key_ON db 1,0,1