;########################################################
;#	Timer based routines and hooks			#
;########################################################
;#	Date of Creation: 23-10-2005			#
;########################################################
;#	Laste changed:	23-10-2005			#
;#							#
;#Changelog:						#
;#							#
;########################################################

include inc\timer.mac

psTable db 1,2,3,4

;none=0/10th	=0	=white
;1=1/10th
;2=2/10th
;3=3/10th
;4=4/10th	
;1+4=5/10th	=1/2 	=gray
;2+4=6/10th
;3+4=7/10th
;1+3+4=8/10th
;2+3+4=9/10th
;1+2+3+4=10/10th=1	=black


;The delay procedure uses the internal clock
;Input: BX time in ticks (1 tick ~ 1/30 second)

ticker dw 0
oldISR_Timer_off dw 0
oldISR_Timer_seg dw 0

_delay proc 
	MOV CS:[ticker],0
	@@wait_loop:
		CMP word ptr CS:[ticker],BX
		JB @@wait_loop
	ret
endp

_setupTimer proc
	PUSH AX ES
	CLI

	XOR AX,AX
	PUSH AX
	POP ES

	MOV AX,word ptr ES:[01Ch*4]
	MOV word ptr CS:[oldISR_Timer_off],AX
	MOV word ptr ES:[01Ch*4],offset __TimerISR

	MOV AX,word ptr ES:[01Ch*4+2]
	MOV word ptr CS:[oldISR_Timer_seg],AX
	MOV word ptr ES:[01Ch*4+2],seg __TimerISR

	STI	;Interrupt has been set up!
	POP ES AX
	ret
endp

_REsetTimer proc
	PUSH AX ES
	CLI

	XOR AX,AX
	PUSH AX
	POP ES

	MOV AX,word ptr CS:[oldISR_Timer_off]
	MOV word ptr ES:[01Ch*4],AX

	MOV AX,word ptr CS:[oldISR_Timer_seg]
	MOV word ptr ES:[01Ch*4+2],AX

	STI	;Interrupt has been set up!
	POP ES AX
	ret
endp


__TimerISR proc
	PUSH DS
	PUSH @CODE
	POP DS
	INC word ptr DS:[ticker]
	CMP PageSwitch,psON
	JNE @@goOn
	PUSH AX
	IN AL,06h
	ADD AL,4
	CMP AL,0B2h
	JB @@write
	@@write: OUT 06h,AL
	;Switch to next screen page ..
	POP AX
      @@goOn:
	POP DS
	CLI
	call _drawMouse
	call _drawMouse
	STI
	Pushf
	call dword ptr cs:[oldISR_Timer_off]
	iret
endp