_InterruptMenu proc 
	;Back up screen ...
	PUSH ES DI DS SI CX AX

	MOV AX,01A20h
	MOV ES,AX
	MOV DS,AX

	XOR SI,SI
	MOV DI,1024*4	;4 Pages --> next 4 pages
	MOV CX,1024*2
	REP MOVSW
;	Cls		;Clear pages

	;PauseBox
	MOV BX,100Ah
	MOV CX,703Ah
	MOV AX,0800h
	call _Rect

	ADD BX,0101h
	MOV CX,6F12h
	MOV AX,0808h
	call _Rect


	MOV CS:[Cursor],120Ch
	Print VM_PauseMenuText

	MOV CS:[Cursor],1213h
	Print VM_SaveAsByteCode
	MOV CS:[Cursor],121Bh
	Print VM_LoadFile
	MOV CS:[Cursor],1222h
	Print VM_RestartProgram
	MOV CS:[Cursor],122Ah
	Print VM_Exit
	MOV CS:[Cursor],1231h

	MOV byte ptr CS:[Narrow],1
	Print VM_DEbug
	MOV byte ptr CS:[Narrow],0

	MOV DI,1
	@@drawer: call _Highlight
	@@WaitLoop: 
		TestKey KEY_Esc
		JE @@goon
		TestKey	KEY_Up
		JE @@up
		TestKey Key_Down
		JE @@down
		TestKey KEY_EXE
	JNE @@WaitLoop		;WARNING! Interrupts are disabled to not interfere with keyboard and mouse handlers!

	CMP DI,4
	JE @@Exit
	CMP DI,3
	JE @@Restart
	CMP DI,5	
	JE @@Debug
	@@goOn:

	MOV AX,01A20h
	MOV ES,AX
	MOV DS,AX

	XOR DI,DI
	MOV SI,1024*4	;4 Pages --> next 4 pages
	MOV CX,1024*2
	REP MOVSW

	@@endVMSetup:
	POP AX cX SI DS DI ES
	ret
	@@down:
		call _HighLight
		@@looper: TestKey KEY_Down	;ignore multi press
		JE @@looper
		INC DI
		CMP DI,6
		JNE @@Drawer
		MOV DI,1
		JMP @@drawer
	@@up:
		call _Highlight
		@@looper1: TestKey KEY_Up	;ignore multi press
		JE @@looper1
		DEC DI
		CMP DI,0	
		JNE @@drawer
		MOV DI,5
		JMP @@drawer
	@@exit:
		MOV byte ptr CS:[terminated],1
	@@restart: 	
		MOV byte ptr CS:[VMReboot],1
		CMP byte ptr CS:[MouseEnabled],YES
		JNE @@endVMSetup 		;Remove mouse if enabled! This MUST be done.
		MOV byte ptr CS:[MouseEnabled],No
		MOV word ptr CS:[Keyboard_Handler],offset _kbd_stub
		JMP @@endVMSetup
	@@Debug:
		PUSHa
		call Invoke_Debugger
		POPa
		JMP @@goOn
endp

HighLights db 13h,1Bh,22h,2Ah,31h,39h

_Highlight proc
	;DI = Item
	PUSH CX BX AX
	MOV BH,11h
	MOV CH,6Fh
	MOV BL,byte ptr CS:[HighLights+DI-1]
	MOV CL,byte ptr CS:[HighLights+DI]
	MOV AX,0A0Ah
	call _Rect
	POP AX BX CX
	ret
endp

VM_PauseMenuText db '%sVM Menu',0
VM_SaveAsByteCode db '%8Save as ...',0
VM_LoadFile db 'Load Bytecode',0
VM_RestartProgram db 'Restart Program',0
VM_Exit db 'Exit MLC2',0
VM_Debug db 'Debug Application',0