;This file, as well as all files it binds with include commands, are
;licensed under the GNU GPL. See a copy here: www.gnu.org/gpl
;If you don't aggree to this license then neither the sources not the
;binary versions of this product may be used.

;If you require a CD with the sources to be shipped to you
;Then mail me at huhn@casiocalc.org and I will ship it to you with shipping and packaging at your expense.

osVersion equ 0004h

.286
MODEL TINY
.STACK 512		;Should be enough stack for now ;)
locals @@
include config.h	;This is the config file. You should not need
			;to edit the sources to tweak the program.

IF Config_Version ne osVersion
	.Err	"Wrong Config Files Version"
ENDIF

.DATA
	;InFile Text Messages
	welcome_msg db 'Loading VM ...%rSystem Version: %n%rText initialized ...%r',0
	set_Graphics db 'Setting Graphics ...%r',0
	done_Graphics db 'Graphics Set up!%r',0

.CODE
	include inc\graphics.inc	;Text procedures (I/O)
	include inc\timer.inc		;Timer based functions
	include inc\keyboard.inc	;Keyboard based functions (cross-linked with mouse)
	include inc\vmCtrl.inc		;PAUSE Menu and controls ...
	include inc\debugger.inc	;The debugger, only included in the test builds, not in the release versions!

	include inc\interprt.inc	;The interpreter for the bytecode
	include inc\compiler.inc	;THe compiler for the MLC2 sourcecode

	include inc\mouse.inc		;Mouse handler function 
	

	IF Instant_Execution eq No
		welcome db '%0Welcome to MLC2',0
		copy db '%8(C) 2006 huhn_m',0
		Version1 db  'Ver: %c/Beta 4',0
		ELSE
		IF Instant_Execution ne Yes
			.ERR "Wrong Value For Instant Execution!"
		ENDIF
	ENDIF

;Temporary files. Will be included in initrd or will be loaded dynamically later
	include inc\font1.inc		;Font
	include inc\mlccode.inc		;The example MLC2 code (for the compiler)

	compiled db 'Compilation finished!%r%r    Press Any Key    %r%rto run the program%r',0
	compiling db 'Compiling sources ....%r% Please wait a moment %r%r',0

    start:
	IF Instant_Execution eq No
		PUSH @DATA
		POP DS		;Assign Data segment to DS
		MOV AX,092Eh	;Write a . (2Eh)
		XOR BX,BX	;To page 0
		MOV CX,1	;exactly 1 times
		INT 10h 	;now to show startup works ...
		ELSE
		IF Instant_Execution ne Yes
			.ERR "Wrong Value For Instant Execution!"
		ENDIF
	ENDIF


	InitText

	IF Instant_Execution eq No
		MOV BX,OSVersion

		Print welcome_msg	;Show text using text based console output
		Print set_Graphics
		ELSE
		IF Instant_Execution ne Yes
			.ERR "Wrong Value For Instant Execution!"
		ENDIF
	ENDIF

	InitGraphics
	SetupTimer
	SetupKeyboard
	Switch psOff		;for using emulator ... turn pageswitch off, all colors are black

	IF Instant_Execution eq No
		MOV cs:[cursor],0B00h+29
		Print done_Graphics
		delay 25


		;Welcome box ...
		CLS

		MOV BX,1010h
		MOV CX,7030h
		MOV AX,0800h
		call _REct

		ADD BX,0101h
		MOV CX,6F18h
		MOV AX,0808h
		call _Rect


		MOV CS:[Cursor],1212h
		Print Welcome
	
		MOV CS:[Cursor],121Bh
		Print copy

		MOV CS:[Cursor],1223h
		MOV BX,OsVersion
		MOV BL,BH
		Print version1


		WaitForAnyKey


		ELSE
		IF Instant_Execution ne Yes
			.ERR "Wrong Value For Instant Execution!"
		ENDIF
	ENDIF
	CLS
	Print Compiling

	Compile mlccode
	
	IF Instant_Execution eq No
		Print Compiled
		WaitForAnyKey
		ELSE
		IF Instant_Execution ne Yes
			.ERR "Wrong Value For Instant Execution!"
		ENDIF
	ENDIF
	
	Run Headder_Target

	IF Instant_Exit eq No
		cli
		call invoke_debugger
		STI
		ELSE
		IF Instant_Exit ne Yes
			.ERR "Wrong Value For Instant Exit!"
		ENDIF
	ENDIF

	InitText
	ResetTimer
	ResetKeyboard

	
	IF Exit_Method ne emReboot
		MOV AX,04C00h	;Terminate execution and return to DOS/CasioMenu
		INT 21h
		ELSE
		IF Exit_Method eq emReboot
			db 0EAH
			dw 00h
			dw 0FFFFh
		ELSE
			.err "No Valid Termination Method Given!"
		ENDIF
	ENDIF
end start		